define(["exports", "require", "../../../lit-element/lit-element.js", "../../simple-colors/simple-colors.js"], function (_exports, _require, _litElement, _simpleColors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HAXAppBrowserItem = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject2_de0277e0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n        :host {\n          display: block;\n        }\n        :host([elevation=\"1\"]) {\n          -webkit-transform: scale(1, 1);\n          transform: scale(1, 1);\n        }\n        :host([elevation=\"2\"]) {\n          -webkit-transform: scale(1.4, 1.4);\n          transform: scale(1.4, 1.4);\n        }\n        paper-button {\n          color: var(--hax-color-text);\n          text-transform: none;\n          background-color: var(--hax-color-bg-accent);\n          min-width: unset;\n          cursor: pointer;\n          display: flex;\n          width: 50px;\n          height: 50px;\n          padding: 5px;\n          margin: 10px;\n          color: #ffffff;\n          border-radius: 50%;\n          box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.14),\n            0 1px 5px 0 rgba(0, 0, 0, 0.12), 0 3px 1px -2px rgba(0, 0, 0, 0.2);\n          -webkit-transition: box-shadow 0.3s;\n          -moz-transition: box-shadow 0.3s;\n          -ms-transition: box-shadow 0.3s;\n          -o-transition: box-shadow 0.3s;\n          transition: box-shadow 0.3s;\n        }\n        paper-button:hover,\n        paper-button:focus {\n          box-shadow: 0 4px 4px 0 rgba(0, 0, 0, 0.14),\n            0 2px 10px 0 rgba(0, 0, 0, 0.12), 0 6px 2px -4px rgba(0, 0, 0, 0.2);\n        }\n        paper-button:active {\n          box-shadow: 0 2px 2px 0 rgba(0, 0, 0, 0.14),\n            0 1px 5px 0 rgba(0, 0, 0, 0.12), 0 3px 1px -2px rgba(0, 0, 0, 0.2);\n        }\n        paper-button iron-icon {\n          height: 32px;\n          width: 32px;\n          color: var(--simple-colors-default-theme-grey-1);\n          display: inline-block;\n        }\n        .item-title {\n          margin-top: 8px;\n          color: var(--hax-color-text);\n          width: 100%;\n          white-space: nowrap;\n          overflow: hidden;\n          text-overflow: ellipsis;\n          font-size: 12px;\n          line-height: 12px;\n          height: 12px;\n          text-align: center;\n        }\n        .button-inner {\n          display: flex;\n        }\n        .flip-icon {\n          transform: rotateY(180deg);\n        }\n      "]);

    _templateObject2_de0277e0e53211e9a0cfefb808989d41 = function _templateObject2_de0277e0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  function _templateObject_de0277e0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <paper-button\n        data-voicecommand=\"select ", "\"\n        title=\"", "\"\n        style=\"background-color:", ";\"\n      >\n        <div class=\"button-inner\">\n          <iron-icon icon=\"", "\" hidden=\"", "\"></iron-icon>\n          <iron-image\n            src=\"", "\"\n            preload=\"\"\n            sizing=\"cover\"\n            hidden=\"", "\"\n          ></iron-image>\n        </div>\n      </paper-button>\n      <div class=\"item-title\" aria-hidden=\"true\">", "</div>\n    "]);

    _templateObject_de0277e0e53211e9a0cfefb808989d41 = function _templateObject_de0277e0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `hax-app-browser-item`
   * `A button on the hax-app-browser display`
   * @microcopy - the mental model for this element
   * - hax-app - data wiring for an app, this element uses the visual side of this
   */
  var HAXAppBrowserItem =
  /*#__PURE__*/
  function (_LitElement) {
    babelHelpers.inherits(HAXAppBrowserItem, _LitElement);
    babelHelpers.createClass(HAXAppBrowserItem, null, [{
      key: "tag",
      get: function get() {
        return "hax-app-browser-item";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Title
           */
          title: {
            type: String
          },

          /**
           * Index position in the original list of imports
           */
          index: {
            type: Number
          },

          /**
           * Icon for the button, optional.
           */
          icon: {
            type: String
          },

          /**
           * Image for the button, optional.
           */
          image: {
            type: String,
            value: false
          },

          /**
           * MaterializeCSS color name of the item
           */
          color: {
            type: String
          },

          /**
           * Class for the color
           */
          hexColor: {
            type: String,
            attribute: "hex-color"
          },

          /**
           * Author related to this app
           */
          author: {
            type: String
          },

          /**
           * Description for this.
           */
          description: {
            type: String
          },

          /**
           * Examples, a list of image links, optional.
           */
          examples: {
            type: Array
          },

          /**
           * Status, whether disabled, enabled, or other future states.
           */
          status: {
            type: Array
          },

          /**
           * Elevation off the UI
           */
          elevation: {
            type: Number,
            reflect: true
          }
        };
      }
    }]);

    function HAXAppBrowserItem() {
      var _this;

      babelHelpers.classCallCheck(this, HAXAppBrowserItem);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HAXAppBrowserItem).call(this));
      _this.elevation = 1;
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-button/paper-button.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/iron-icon/iron-icon.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/iron-image/iron-image.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(HAXAppBrowserItem, [{
      key: "render",
      value: function render() {
        return (0, _litElement.html)(_templateObject_de0277e0e53211e9a0cfefb808989d41(), this.title, this.title, this.hexColor, this.icon, !this.icon, this.image, !this.image, this.title);
      }
    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(HAXAppBrowserItem.prototype), "connectedCallback", this).call(this);
        this.addEventListener("click", this._fireEvent);
        this.addEventListener("mousedown", this.tapEventOn);
        this.addEventListener("mouseover", this.tapEventOn);
        this.addEventListener("mouseout", this.tapEventOff);
        this.addEventListener("focusin", this.tapEventOn);
        this.addEventListener("focusout", this.tapEventOff);
      }
      /**
       * special handling for taps on the thing
       */

    }, {
      key: "tapEventOn",
      value: function tapEventOn(e) {
        this.elevation = 2;
      }
      /**
       * Hover off stop showing the deeper shadow.
       */

    }, {
      key: "tapEventOff",
      value: function tapEventOff(e) {
        this.elevation = 1;
      }
    }, {
      key: "_getHexColor",
      value: function _getHexColor(color) {
        var name = color.replace("-text", "");
        var tmp = new _simpleColors.SimpleColors();

        if (tmp.colors[name]) {
          return tmp.colors[name][6];
        }

        return "#000000";
      }
    }, {
      key: "updated",
      value: function updated(changedProperties) {
        var _this2 = this;

        changedProperties.forEach(function (oldValue, propName) {
          // update hexcolor when color changes
          if (propName === "color") {
            _this2.hexColor = _this2._getHexColor(_this2.color);
          }
        });
      }
      /**
       * Fire an event that includes the eventName of what was just pressed.
       */

    }, {
      key: "_fireEvent",
      value: function _fireEvent(e) {
        this.dispatchEvent(new CustomEvent("hax-app-selected", {
          bubbles: true,
          cancelable: true,
          composed: true,
          detail: this.index
        }));
      }
    }], [{
      key: "styles",
      get: function get() {
        return [(0, _litElement.css)(_templateObject2_de0277e0e53211e9a0cfefb808989d41())];
      }
    }]);
    return HAXAppBrowserItem;
  }(_litElement.LitElement);

  _exports.HAXAppBrowserItem = HAXAppBrowserItem;
  customElements.define(HAXAppBrowserItem.tag, HAXAppBrowserItem);
});