define(["exports", "require", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/polymer/lib/utils/render-status.js", "../../../@polymer/polymer/lib/utils/async.js", "../../simple-colors/simple-colors.js", "../../grafitto-filter/grafitto-filter.js", "../../../@polymer/iron-list/iron-list.js", "../../../@polymer/iron-pages/iron-pages.js", "./hax-shared-styles.js"], function (_exports, _require, _polymerElement, _renderStatus, _async, _simpleColors, _grafittoFilter, _ironList, _ironPages, _haxSharedStyles) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxAppBrowser = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_de19f780e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n        }\n        :host *[hidden] {\n          display: none;\n        }\n        #ironlist {\n          min-height: 132px;\n          margin: 0;\n          padding: 10px;\n        }\n        hax-app-browser-item {\n          margin: 8px;\n          -webkit-transition: 0.3s all linear;\n          transition: 0.3s all linear;\n        }\n        .title {\n          position: relative;\n          padding: 16px;\n          outline: 0;\n          font-weight: 600;\n          text-align: left;\n          margin: 0;\n          background-color: var(--hax-color-menu-heading-bg);\n          font-size: 18px;\n          line-height: 18px;\n          font-family: \"Noto Serif\", serif;\n          color: var(--hax-color-menu-heading-color);\n        }\n        grafitto-filter {\n          color: black;\n        }\n        .toolbar-inner {\n          display: inline-flex;\n          padding: 0 16px;\n        }\n      </style>\n      <h3 class=\"title\">[[title]]</h3>\n      <div class=\"toolbar-inner\">\n        <dropdown-select\n          id=\"filtertype\"\n          label=\"Filter by\"\n          value=\"details.title\"\n        >\n          <paper-item value=\"details.title\">Title</paper-item>\n        </dropdown-select>\n        <paper-input\n          label=\"Filter\"\n          id=\"inputfilter\"\n          aria-controls=\"filter\"\n          value=\"\"\n          always-float-label=\"\"\n        ></paper-input>\n      </div>\n      <grafitto-filter\n        id=\"filter\"\n        items=\"[[__appList]]\"\n        like=\"\"\n        where=\"details.title\"\n        as=\"filtered\"\n      >\n        <template>\n          <iron-list id=\"ironlist\" items=\"[[filtered]]\" as=\"app\" grid=\"\">\n            <template>\n              <div class=\"app-container\">\n                <hax-app-browser-item\n                  index=\"[[app.index]]\"\n                  title=\"[[app.details.title]]\"\n                  icon=\"[[app.details.icon]]\"\n                  image=\"[[app.details.tag]]\"\n                  color=\"[[app.details.color]]\"\n                  meta=\"[[app.details.meta]]\"\n                  groups=\"[[app.details.groups]]\"\n                  handles=\"[[app.details.handles]]\"\n                  description=\"[[app.details.description]]\"\n                  rating=\"[[app.details.rating]]\"\n                  tags=\"[[app.details.tags]]\"\n                ></hax-app-browser-item>\n              </div>\n            </template>\n          </iron-list>\n        </template>\n      </grafitto-filter>\n      <hax-app-search\n        id=\"haxappsearch\"\n        hidden$=\"[[!searching]]\"\n      ></hax-app-search>\n      <slot></slot>\n    "]);

    _templateObject_de19f780e53211e9a0cfefb808989d41 = function _templateObject_de19f780e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `hax-app-browser`
   * `Browse a list of apps. This provides a listing of our gizmos that we've integrated with.`
   * @microcopy - the mental model for this element
   * - hax-app - expression of how to communicate and visualize a data source
   * - gizmo - silly name for the general public when talking about hax-app and what it provides in the end
   */
  var HaxAppBrowser =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(HaxAppBrowser, _PolymerElement);

    function HaxAppBrowser() {
      var _this;

      babelHelpers.classCallCheck(this, HaxAppBrowser);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HaxAppBrowser).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-input/paper-input.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../@polymer/paper-item/paper-item.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../dropdown-select/dropdown-select.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["./hax-app-browser-item.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["./hax-app-search.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(HaxAppBrowser, [{
      key: "connectedCallback",

      /**
       * life cycle
       */
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(HaxAppBrowser.prototype), "connectedCallback", this).call(this);
        this.resetBrowser();
      }
    }, {
      key: "ready",
      value: function ready() {
        babelHelpers.get(babelHelpers.getPrototypeOf(HaxAppBrowser.prototype), "ready", this).call(this);
        (0, _renderStatus.afterNextRender)(this, function () {
          var _this2 = this;

          this.shadowRoot.querySelector("#inputfilter").addEventListener("value-changed", function (e) {
            _this2.shadowRoot.querySelector("#filter").like = e.target.value;
          });
          this.shadowRoot.querySelector("#filtertype").addEventListener("change", function (e) {
            _this2.shadowRoot.querySelector("#inputfilter").value = "";
            _this2.shadowRoot.querySelector("#filter").where = e.detail.value;
            _this2.shadowRoot.querySelector("#filter").like = "";
          });
          document.body.addEventListener("hax-app-selected", this._appSelected.bind(this));
          document.body.addEventListener("hax-store-property-updated", this._haxStorePropertyUpdated.bind(this));
        });
      }
      /**
       * App has been selected.
       */

    }, {
      key: "_appSelected",
      value: function _appSelected(e) {
        // item bubbled up
        if (babelHelpers.typeof(e.detail) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          this.set("__activeApp", e.detail);
          this.searching = true;
          window.HaxStore.write("activeApp", this.__appList[e.detail], this);
        }
      }
      /**
       * Active app updated, so scroll it into view
       */

    }, {
      key: "_activeAppChanged",
      value: function _activeAppChanged(newValue, oldValue) {
        if (babelHelpers.typeof(oldValue) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && newValue != null) {
          window.HaxStore.instance.haxManager.searching = true;
          this.hasActive = true;
        } else {
          this.hasActive = false;
        }
      }
      /**
       * Store updated, sync.
       */

    }, {
      key: "_haxStorePropertyUpdated",
      value: function _haxStorePropertyUpdated(e) {
        if (e.detail && babelHelpers.typeof(e.detail.value) !== (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined)) && e.detail.property) {
          this.set(e.detail.property, e.detail.value);
        }
      }
      /**
       * Reset this browser.
       */

    }, {
      key: "resetBrowser",
      value: function resetBrowser() {
        var _this3 = this;

        _async.microTask.run(function () {
          _this3.searching = false;

          _this3.set("__appList", window.HaxStore.instance.appList);

          if (_this3.shadowRoot.querySelector("#filter").shadowRoot.querySelector("#ironlist")) {
            _this3.shadowRoot.querySelector("#filter").shadowRoot.querySelector("#ironlist").filtered = _this3.__appList;
          }

          _this3.shadowRoot.querySelector("#inputfilter").value = "";
          _this3.shadowRoot.querySelector("#filtertype").value = "details.title";
          _this3.shadowRoot.querySelector("#filter").value = "";

          _this3.shadowRoot.querySelector("#filter").filter();

          _this3.shadowRoot.querySelector("#filter").where = "details.title";
          _this3.shadowRoot.querySelector("#filter").like = "";
          setTimeout(function () {
            if (_this3.shadowRoot.querySelector("#filter").shadowRoot.querySelector("#ironlist")) {
              _this3.shadowRoot.querySelector("#filter").shadowRoot.querySelector("#ironlist").dispatchEvent(new CustomEvent("iron-resize", {
                bubbles: true,
                cancelable: true,
                composed: true,
                detail: true
              }));

              window.dispatchEvent(new Event("resize"));
            }
          }, 100);
        });
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_de19f780e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "hax-app-browser";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Search term
           */
          search: {
            type: String
          },

          /**
           * Title of the browser, for translation.
           */
          title: {
            type: String,
            value: "Find"
          },

          /**
           * Searching mode
           */
          searching: {
            type: Boolean,
            reflectToAttribute: true,
            value: false
          },

          /**
           * Global activeApp object.
           */
          activeApp: {
            type: Object,
            value: null,
            observer: "_activeAppChanged"
          },

          /**
           * If we have an active, scale everything
           */
          hasActive: {
            reflectToAttribute: true,
            value: false,
            type: Boolean
          }
        };
      }
    }]);
    return HaxAppBrowser;
  }(_polymerElement.PolymerElement);

  _exports.HaxAppBrowser = HaxAppBrowser;
  window.customElements.define(HaxAppBrowser.tag, HaxAppBrowser);
});