define(["exports", "./hax-app.js"], function (_exports, _haxApp) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HAXBlox = void 0;

  /**
   `hax-blox`
  Register a blox with HAX store.
  
  * @demo demo/index.html
  
  @microcopy - the mental model for this element
   - blox - A definition for a grid plate element
   - data - this is the blox data model which expresses itself to hax
  
  @example data call
  ```
  [{
    "details": {
      "title": "Example text and meme",
      "image": "example-meme.jpg",
      "author": "ELMS:LN",
      "description": "A well organized example list of objectives.",
      "status": "available",
      "rating": "0",
      "tags": ["instructional design", "list"]
    },
    "blox": [
      {
        "tag": "p",
        "properties": {},
        "content": "It is an ethical imperative that we seek the fundamental transformation of higher education to maximize quality and access to knowledge. This transformation will empower the globe to increase empathy, maximize personal freedom and personal growth through increased educational equality."
      },
      {
        "tag": "meme-maker",
        "properties": {
          "image-url": "https://media1.giphy.com/media/3o7TKMOy5zz1nuD71u/giphy.gif",
          "alt": "sun moon GIF by Amy Ciavolino",
          "top-text": "Sup, suuuuuun?",
          "bottom-text": "Hax, Moon. Hax."
        },
        "content": ""
      }
    ]
  }]
  ```
  */
  var HAXBlox =
  /*#__PURE__*/
  function (_HAXApp) {
    babelHelpers.inherits(HAXBlox, _HAXApp);

    function HAXBlox() {
      var _this;

      babelHelpers.classCallCheck(this, HAXBlox);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HAXBlox).call(this));
      _this.eventName = "hax-register-blox";
      return _this;
    }

    babelHelpers.createClass(HAXBlox, null, [{
      key: "tag",
      get: function get() {
        return "hax-blox";
      }
    }]);
    return HAXBlox;
  }(_haxApp.HAXApp);

  _exports.HAXBlox = HAXBlox;
  window.customElements.define(HAXBlox.tag, HAXBlox);
});