define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../rich-text-editor/lib/buttons/rich-text-editor-prompt-button.js", "../../lrn-vocab/lrn-vocab.js"], function (_exports, _polymerElement, _richTextEditorPromptButton, _lrnVocab) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.HaxTextEditorVocab = void 0;

  /**
   * Copyright 2019 Penn State University
   * @license Apache-2.0, see License.md for full text.
   */

  /**
   * `hax-text-editor-vocab`
   * `a lrn-vocab button for hax text editor (custom buttons can extend this)`
   *
   * @microcopy - language worth noting:
   *  -
   *
   * @customElement
   * @polymer
   */
  var HaxTextEditorVocab =
  /*#__PURE__*/
  function (_RichTextEditorPrompt) {
    babelHelpers.inherits(HaxTextEditorVocab, _RichTextEditorPrompt);

    function HaxTextEditorVocab() {
      var _this;

      babelHelpers.classCallCheck(this, HaxTextEditorVocab);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(HaxTextEditorVocab).call(this));
      _this.inlineWidget = true;
      var element = _lrnVocab.LrnVocab;
      _this.tag = element.tag;
      _this.icon = element.haxProperties.gizmo.icon;
      _this.label = element.haxProperties.gizmo.title;
      _this.fields = element.haxProperties.settings.configure;
      _this.toggles = true;
      _this.value = {
        "": null
      };
      return _this;
    } // properties available to the custom element for data binding


    babelHelpers.createClass(HaxTextEditorVocab, null, [{
      key: "properties",
      get: function get() {
        return {};
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }, {
      key: "tag",
      get: function get() {
        return "hax-text-editor-vocab";
      }
    }]);
    return HaxTextEditorVocab;
  }(_richTextEditorPromptButton.RichTextEditorPromptButton);

  _exports.HaxTextEditorVocab = HaxTextEditorVocab;
  window.customElements.define(HaxTextEditorVocab.tag, HaxTextEditorVocab);
});