define(["exports", "require", "../../../../../@polymer/polymer/polymer-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js", "../../../../../@polymer/paper-button/paper-button.js"], function (_exports, _require, _polymerElement, _haxcmsSiteStore, _mobxModule, _paperButton) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteMenuButton = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_10c835c0e53311e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          font-size: 16px;\n          transition: 0.3s all ease-in-out;\n        }\n        :host([disabled]) {\n          pointer-event: none;\n          opacity: 0.3;\n        }\n        a {\n          color: black;\n          text-decoration: underline;\n          @apply --site-menu-button-link;\n        }\n        paper-button {\n          transition: 0.3s all ease-in-out;\n          min-width: unset;\n          @apply --site-menu-button-button;\n        }\n        paper-button:hover,\n        paper-button:focus,\n        paper-button:active {\n          @apply --site-menu-button-button-hover;\n        }\n        iron-icon {\n          display: block;\n          font-size: 16px;\n          @apply --site-menu-button-icon;\n        }\n        paper-tooltip {\n          --paper-tooltip-background: var(\n            --site-menu-button-tooltip-bg,\n            #000000\n          );\n          --paper-tooltip-opacity: 1;\n          --paper-tooltip-text-color: var(\n            --site-menu-button-tooltip-text,\n            #ffffff\n          );\n          --paper-tooltip-delay-in: 0;\n          --paper-tooltip: {\n            border-radius: 0;\n          }\n        }\n      </style>\n      <a\n        tabindex=\"-1\"\n        href$=\"[[link]]\"\n        disabled$=\"[[disabled]]\"\n        title$=\"[[label]]\"\n      >\n        <paper-button\n          id=\"menulink\"\n          noink\n          disabled=\"[[disabled]]\"\n          raised=\"[[raised]]\"\n          title=\"[[label]]\"\n        >\n          <slot name=\"prefix\"></slot>\n          <iron-icon icon=\"[[icon]]\"></iron-icon>\n          <slot name=\"suffix\"></slot>\n        </paper-button>\n      </a>\n      <paper-tooltip for=\"menulink\" offset=\"8\" position=\"[[position]]\">\n        [[label]]\n      </paper-tooltip>\n    "]);

    _templateObject_10c835c0e53311e9a0cfefb808989d41 = function _templateObject_10c835c0e53311e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `site-menu-button`
   * `Menu button based on the hierarchy`
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  var SiteMenuButton =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(SiteMenuButton, _PolymerElement);
    babelHelpers.createClass(SiteMenuButton, null, [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "site-menu-button";
      }
    }]);

    function SiteMenuButton() {
      var _this;

      babelHelpers.classCallCheck(this, SiteMenuButton);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SiteMenuButton).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/iron-icon/iron-icon.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/iron-icons/iron-icons.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/paper-tooltip/paper-tooltip.js"], res, rej);
      });
      return _this;
    } // render function


    babelHelpers.createClass(SiteMenuButton, [{
      key: "_typeChanged",
      value: function _typeChanged(newValue) {
        if (newValue === "prev") {
          if (!this.label) {
            this.label = "Previous page";
          }

          if (!this.icon) {
            this.icon = "icons:chevron-left";
          }

          if (!this.position) {
            this.position = "right";
          }
        } else if (newValue === "next") {
          if (!this.label) {
            this.label = "Next page";
          }

          if (!this.icon) {
            this.icon = "icons:chevron-right";
          }

          if (!this.position) {
            this.position = "left";
          }
        } // @todo add support for up and down as far as children and parent relationships
        else {
            this.label = "";
            this.icon = "";
            this.direction = "";
          }
      }
    }, {
      key: "pageLink",
      value: function pageLink(type, activeRouterManifestIndex, items) {
        if (type === "prev" && items) {
          if (activeRouterManifestIndex > 0 && items[activeRouterManifestIndex - 1]) {
            return items[activeRouterManifestIndex - 1].location;
          }

          return null;
        } else if (type === "next" && items) {
          if (activeRouterManifestIndex < items.length - 1 && items[activeRouterManifestIndex + 1]) {
            return items[activeRouterManifestIndex + 1].location;
          }

          return null;
        } // @todo add support for up and down as far as children and parent relationships
        else {
            return null;
          }
      }
    }, {
      key: "pageLinkStatus",
      value: function pageLinkStatus(type, activeRouterManifestIndex, items, editMode) {
        if (editMode) {
          return true;
        }

        if (type === "prev") {
          if (activeRouterManifestIndex === 0 || activeRouterManifestIndex === -1) {
            return true;
          }
        } else if (type === "next" && items) {
          if (activeRouterManifestIndex >= items.length - 1) {
            return true;
          }
        }

        return false;
      }
    }, {
      key: "connectedCallback",
      value: function connectedCallback() {
        var _this2 = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteMenuButton.prototype), "connectedCallback", this).call(this);
        this.__disposer = (0, _mobxModule.autorun)(function () {
          _this2.routerManifest = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.routerManifest);
        });
        this.__disposer2 = (0, _mobxModule.autorun)(function () {
          _this2.activeRouterManifestIndex = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.activeRouterManifestIndex);
        });
        this.__disposer3 = (0, _mobxModule.autorun)(function () {
          _this2.editMode = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.editMode);
        });
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        this.__disposer();

        this.__disposer2();

        this.__disposer3();

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteMenuButton.prototype), "disconnectedCallback", this).call(this);
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_10c835c0e53311e9a0cfefb808989d41());
      }
      /**
       * Props
       */

    }, {
      key: "properties",
      get: function get() {
        return {
          type: {
            type: String,
            observer: "_typeChanged",
            reflectToAttribute: true
          },

          /**
           * acitvely selected item
           */
          activeRouterManifestIndex: {
            type: String
          },
          routerManifest: {
            type: Object
          },
          link: {
            type: String,
            computed: "pageLink(type, activeRouterManifestIndex, routerManifest.items)"
          },
          editMode: {
            type: Boolean
          },
          disabled: {
            type: Boolean,
            reflectToAttribute: true,
            computed: "pageLinkStatus(type, activeRouterManifestIndex, routerManifest.items, editMode)"
          },
          label: {
            type: String
          },
          icon: {
            type: String
          },
          position: {
            type: String
          },
          raised: {
            type: Boolean
          }
        };
      }
    }]);
    return SiteMenuButton;
  }(_polymerElement.PolymerElement);

  _exports.SiteMenuButton = SiteMenuButton;
  window.customElements.define(SiteMenuButton.tag, SiteMenuButton);
});