define(["exports", "require", "../../../../../@polymer/polymer/polymer-element.js", "../../core/haxcms-site-store.js", "../../../../../mobx/lib/mobx.module.js"], function (_exports, _require, _polymerElement, _haxcmsSiteStore, _mobxModule) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteMenu = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_10f49cf0e53311e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          height: 100vh;\n        }\n        map-menu[disabled] {\n          pointer-events: none;\n          opacity: 0.5;\n          background-color: grey;\n        }\n        map-menu:not(:defined) {\n          display: none;\n        }\n        map-menu {\n          @apply --site-menu;\n          --map-menu-active-color: var(--site-menu-active-color);\n          --map-menu-container: var(--site-menu-container);\n          --map-menu-item-active-item: var(--site-menu-item-active-item);\n        }\n\n        map-menu::-webkit-scrollbar-track {\n          -webkit-box-shadow: inset 0 0 4px\n            var(--site-menu-scrolltrack-bg-color, rgba(56, 63, 69, 0.9));\n          border-radius: 0;\n          background-color: var(--site-menu-bg-color, #383f45);\n        }\n        map-menu::-webkit-scrollbar {\n          width: 2px;\n          background-color: var(--site-menu-bg-color, #383f45);\n        }\n        map-menu::-webkit-scrollbar-thumb {\n          border-radius: 1px;\n          -webkit-box-shadow: inset 0 0 4px var(--site-menu-bg-shadow, #747474);\n          background-color: var(--site-menu-bg-color, #383f45);\n        }\n      </style>\n      <map-menu\n        disabled=\"[[editMode]]\"\n        selected=\"[[activeId]]\"\n        manifest=\"[[routerManifest]]\"\n        active-indicator=\"[[!hideActiveIndicator]]\"\n        auto-scroll=\"[[!preventAutoScroll]]\"\n      ></map-menu>\n    "]);

    _templateObject_10f49cf0e53311e9a0cfefb808989d41 = function _templateObject_10f49cf0e53311e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `site-menu`
   * `Menu hierarchy`
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  var SiteMenu =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(SiteMenu, _PolymerElement);
    babelHelpers.createClass(SiteMenu, null, [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "site-menu";
      }
    }]);

    function SiteMenu() {
      var _this;

      babelHelpers.classCallCheck(this, SiteMenu);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SiteMenu).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../../../map-menu/map-menu.js"], res, rej);
      });
      return _this;
    } // render function


    babelHelpers.createClass(SiteMenu, [{
      key: "connectedCallback",
      value: function connectedCallback() {
        var _this2 = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(SiteMenu.prototype), "connectedCallback", this).call(this);
        this.__disposer = (0, _mobxModule.autorun)(function () {
          _this2.routerManifest = Object.assign({}, (0, _mobxModule.toJS)(_haxcmsSiteStore.store.routerManifest));
        }); // silly but delay to ensure highlighting happens

        setTimeout(function () {
          _this2.__disposer2 = (0, _mobxModule.autorun)(function () {
            _this2.activeId = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.activeId);
          });
        }, 100);
        this.__disposer3 = (0, _mobxModule.autorun)(function () {
          _this2.editMode = (0, _mobxModule.toJS)(_haxcmsSiteStore.store.editMode);
        });
        this.shadowRoot.querySelector("map-menu").addEventListener("active-item", this.mapMenuActiveChanged.bind(this));
      }
    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(SiteMenu.prototype), "disconnectedCallback", this).call(this);

        this.__disposer();

        this.__disposer3();

        if (this.__disposer2) {
          this.__disposer2();
        }

        this.shadowRoot.querySelector("map-menu").removeEventListener("active-item", this.mapMenuActiveChanged.bind(this));
      }
      /**
       * When map menu changes let's set a track icon internal to it.
       */

    }, {
      key: "mapMenuActiveChanged",
      value: function mapMenuActiveChanged(e) {
        // update the UI directly
        e.detail.trackIcon = this.trackIcon; // now work on the user data object in the theme layer

        var userData = JSON.parse(window.localStorage.getItem("HAXCMSSystemData"));

        if (userData.manifests && babelHelpers.typeof(userData.manifests[this.routerManifest.id]) === (typeof undefined === "undefined" ? "undefined" : babelHelpers.typeof(undefined))) {
          userData.manifests[this.routerManifest.id] = {
            accessData: {}
          };
        } // edge case when switching rapidly


        if (!userData.manifests[this.routerManifest.id].accessData) {
          userData.manifests[this.routerManifest.id].accessData = {};
        }

        userData.manifests[this.routerManifest.id].accessData[e.detail.id] = {
          timestamp: Math.floor(Date.now() / 1000),
          trackIcon: this.trackIcon
        };

        for (var i in this.routerManifest.items) {
          if (this.routerManifest.items[i].id === e.detail.id) {
            this.routerManifest.items[i].metadata.accessData = userData.manifests[this.routerManifest.id].accessData[e.detail.id];
          }
        } // save this back to the system data


        window.localStorage.setItem("HAXCMSSystemData", JSON.stringify(userData));
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_10f49cf0e53311e9a0cfefb808989d41());
      }
      /**
       * Props
       */

    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Manifest with router / location enhancements
           */
          routerManifest: {
            type: Object
          },

          /**
           * acitvely selected item
           */
          activeId: {
            type: String
          },

          /**
           * Binding for active indicator and auto scrolling
           */
          hideActiveIndicator: {
            type: Boolean,
            value: false
          },

          /**
           * prevent the automatic scrolling when items become active
           */
          preventAutoScroll: {
            type: Boolean,
            value: false
          },

          /**
           * allow for visualizing the tracking of page requests
           */
          trackIcon: {
            type: String,
            value: ""
          }
        };
      }
    }]);
    return SiteMenu;
  }(_polymerElement.PolymerElement);

  _exports.SiteMenu = SiteMenu;
  window.customElements.define(SiteMenu.tag, SiteMenu);
});