define(["exports", "require", "../../../../../@polymer/polymer/polymer-element.js"], function (_exports, _require, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.SiteRSSButton = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_11eedb70e53311e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          font-size: 16px;\n          color: var(--site-rss-color, #383f45);\n        }\n        a {\n          text-decoration: var(--site-rss-text-decoration, none);\n        }\n        paper-button {\n          text-transform: unset;\n          color: white;\n          background-color: var(--site-rss-bg-color, #383f45);\n          font-size: var(--site-rss-font-size, 13px);\n          margin: 0;\n          border-radius: var(--site-rss-border-radius, 3px);\n          @apply --site-rss-paper-button;\n        }\n        paper-button:hover,\n        paper-button:focus,\n        paper-button:active {\n          background-color: var(--site-rss-bg-active, #2d3237);\n        }\n      </style>\n      <a\n        disabled$=\"[[disabled]]\"\n        tabindex=\"-1\"\n        href$=\"[[href]]\"\n        target=\"_blank\"\n        rel=\"noopener noreferrer\"\n      >\n        <paper-button raised=\"[[raised]]\">\n          <iron-icon icon=\"[[icon]]\"></iron-icon> [[label]]\n        </paper-button>\n      </a>\n    "]);

    _templateObject_11eedb70e53311e9a0cfefb808989d41 = function _templateObject_11eedb70e53311e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `site-rss-button`
   * `A button that references RSS feeds in a standards based way`
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  var SiteRSSButton =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(SiteRSSButton, _PolymerElement);
    babelHelpers.createClass(SiteRSSButton, null, [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "site-rss-button";
      }
    }]);

    function SiteRSSButton() {
      var _this;

      babelHelpers.classCallCheck(this, SiteRSSButton);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(SiteRSSButton).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/paper-button/paper-button.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/iron-icon/iron-icon.js"], res, rej);
      });
      new Promise(function (res, rej) {
        return _require.default(["../../../../../@polymer/iron-icons/communication-icons.js"], res, rej);
      });
      return _this;
    } // render function


    babelHelpers.createClass(SiteRSSButton, [{
      key: "_generateLink",

      /**
       * Generate a link when we get a new type.
       */
      value: function _generateLink(newValue, oldValue) {
        // remove existing if this is moving around
        if (this._link) {
          document.head.removeChild(this._link);
        }

        if (newValue) {
          var link = document.createElement("link");
          link.rel = "alternate";

          if (newValue === "rss") {
            link.href = "rss.xml";
            link.title = "RSS feed";
            link.type = "application/rss+xml";
            this.icon = "communication:rss-feed";
          } else if (newValue === "atom") {
            link.href = "atom.xml";
            link.title = "Atom feed";
            link.type = "application/atom+xml";
            this.icon = "communication:rss-feed";
          }

          this.label = link.title;
          this.href = link.href;
          document.head.appendChild(link);
          this._link = link;
        }
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_11eedb70e53311e9a0cfefb808989d41());
      }
      /**
       * Mix in an opened status
       */

    }, {
      key: "properties",
      get: function get() {
        return {
          disabled: {
            type: Boolean,
            reflectToAttribute: true
          },
          type: {
            type: String,
            value: "rss",
            observer: "_generateLink"
          },
          raised: {
            type: Boolean,
            value: false,
            reflectToAttribute: true
          }
        };
      }
    }]);
    return SiteRSSButton;
  }(_polymerElement.PolymerElement);

  _exports.SiteRSSButton = SiteRSSButton;
  window.customElements.define(SiteRSSButton.tag, SiteRSSButton);
});