define(["exports", "require", "../../@polymer/polymer/polymer-element.js"], function (_exports, _require, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnAside = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  function _templateObject_9910a080e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: flex;\n          padding: 8px;\n        }\n        :host([sticky]) {\n          top: 0;\n          position: sticky;\n        }\n        :host([direction=\"left\"]) {\n          float: left;\n          max-width: 480px;\n        }\n        :host([direction=\"right\"]) {\n          float: right;\n          max-width: 480px;\n        }\n      </style>\n      <aside>\n        <lrndesign-panelcard title=\"[[title]]\">\n          <slot></slot>\n        </lrndesign-panelcard>\n      </aside>\n    "]);

    _templateObject_9910a080e53211e9a0cfefb808989d41 = function _templateObject_9910a080e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `lrn-aside`
   * A content aside as a panel
   *
   * @demo demo/index.html
   */
  var LrnAside =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(LrnAside, _PolymerElement);

    function LrnAside() {
      var _this;

      babelHelpers.classCallCheck(this, LrnAside);
      _this = babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrnAside).call(this));
      new Promise(function (res, rej) {
        return _require.default(["../lrndesign-panelcard/lrndesign-panelcard.js"], res, rej);
      });
      return _this;
    }

    babelHelpers.createClass(LrnAside, null, [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_9910a080e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "lrn-aside";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Title for the aside.
           */
          title: {
            type: String,
            value: "Related content"
          },

          /**
           * Apply CSS sticky styling
           */
          sticky: {
            type: Boolean,
            value: false,
            reflectToAttribute: true
          },

          /**
           * Direction to hang off UI if sticky, left or right.
           */
          direction: {
            type: String,
            value: "",
            reflectToAttribute: true
          }
        };
      }
      /**
       * Attached to the DOM, now fire.
       */

    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Sticky note",
            description: "A sticky note to present some basic info offset on the page.",
            icon: "av:note",
            color: "yellow",
            groups: ["Content"],
            handles: [{
              type: "text",
              title: "title"
            }],
            meta: {
              author: "LRNWebComponents"
            }
          },
          settings: {
            quick: [{
              property: "title",
              title: "Title",
              description: "Enter title for sticky note",
              inputMethod: "textfield",
              required: true
            }],
            configure: [{
              property: "title",
              title: "Title",
              description: "Enter title for sticky note.",
              inputMethod: "textfield",
              required: true
            }, {
              slot: "",
              title: "Content",
              description: "Content of the sticky note",
              inputMethod: "code-editor",
              required: true
            }, {
              property: "sticky",
              title: "Stick to page on scroll",
              description: "Appear sticky when the user scrolls past it",
              inputMethod: "boolean"
            }, {
              property: "direction",
              title: "Direction to hang",
              description: "Location of the sticky note to hang",
              inputMethod: "select",
              options: {
                "": "none",
                right: "Right",
                left: "Left"
              }
            }],
            advanced: []
          }
        };
      }
    }]);
    return LrnAside;
  }(_polymerElement.PolymerElement);

  _exports.LrnAside = LrnAside;
  window.customElements.define(LrnAside.tag, LrnAside);
});