define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/paper-fab/paper-fab.js", "../../../@polymer/iron-flex-layout/iron-flex-layout-classes.js", "../../materializecss-styles/lib/colors.js"], function (_exports, _polymerElement, _paperFab, _ironFlexLayoutClasses, _colors) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappFabSpeedDialAction = void 0;

  function _templateObject_e8c59860e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style\n        include=\"iron-flex iron-flex-alignment materializecss-styles-colors\"\n      >\n        :host {\n          @apply --layout-horizontal;\n          @apply --layout-center;\n          @apply --layout-end-justified;\n          margin-top: 15px;\n          margin-right: 8px;\n          min-width: 270px;\n        }\n        .label {\n          color: black;\n          background: white;\n          padding: 0 16px;\n          border-radius: 4px;\n          margin-right: 24px;\n        }\n        .fab {\n          --lrnapp-fab-background: var(\n            --lrnapp-fab-speed-dial-action-background\n          );\n          --lrnapp-fab-keyboard-focus-background: var(\n            --lrnapp-fab-speed-dial-action-keyboard-focus-background\n          );\n        }\n        .label,\n        .fab {\n          display: flex;\n        }\n      </style>\n      <div class=\"flex\">\n        <span class=\"label\"><slot></slot></span>\n      </div>\n      <paper-fab class$=\"fab [[color]]\" icon=\"[[icon]]\" mini></paper-fab>\n    "]);

    _templateObject_e8c59860e53211e9a0cfefb808989d41 = function _templateObject_e8c59860e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /*
  An action within a material design [Floating Action Button with Speed Dial](https://www.google.com/design/spec/components/buttons-floating-action-button.html#buttons-floating-action-button-transitions)
  
  ### Styling
  
  Style                                                   | Description
  ------------------------------------------------------- | ------------
  --lrnapp-fab-speed-dial-action-background                | The background color of the Floating Action Button
  --lrnapp-fab-speed-dial-action-keyboard-focus-background | The background color of the Floating Action Button when focused
  
  ### Example
  
  ```html
  <lrnapp-fab-speed-dial-action icon="icons:content-copy">Copy</lrnapp-fab-speed-dial-action>
  ```
  
  * @demo demo/index.html
  */
  var LrnappFabSpeedDialAction =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(LrnappFabSpeedDialAction, _PolymerElement);

    function LrnappFabSpeedDialAction() {
      babelHelpers.classCallCheck(this, LrnappFabSpeedDialAction);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrnappFabSpeedDialAction).apply(this, arguments));
    }

    babelHelpers.createClass(LrnappFabSpeedDialAction, null, [{
      key: "tag",
      get: function get() {
        return "lrnapp-fab-speed-dial-action";
      }
    }, {
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_e8c59860e53211e9a0cfefb808989d41());
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Icon that is shown next to the content
           */
          icon: {
            type: String
          },

          /**
           * Color class work to apply
           */
          color: {
            type: String,
            value: "blue"
          }
        };
      }
    }]);
    return LrnappFabSpeedDialAction;
  }(_polymerElement.PolymerElement);

  _exports.LrnappFabSpeedDialAction = LrnappFabSpeedDialAction;
  window.customElements.define(LrnappFabSpeedDialAction.tag, LrnappFabSpeedDialAction);
});