define(["exports", "../../../@polymer/polymer/polymer-element.js"], function (_exports, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignGalleryDetails = void 0;

  function _templateObject_e90846b0e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n        }\n        :host([hidden]) {\n          display: none;\n        }\n      </style>\n      <div id=\"details\"></div>\n    "]);

    _templateObject_e90846b0e53211e9a0cfefb808989d41 = function _templateObject_e90846b0e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `lrndesign-gallery-details`
   * `An element that renders the print view of a gallery item.`
   *
   * @microcopy - language worth noting:```
  <lrndesign-gallery-details 
    details="<strong>HTML MARKUP HERE</strong>"       //required, an array of item data
  </lrndesign-gallery-details>```
   *
   * @customElement
   * @polymer
   */
  var LrndesignGalleryDetails =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(LrndesignGalleryDetails, _PolymerElement);

    function LrndesignGalleryDetails() {
      babelHelpers.classCallCheck(this, LrndesignGalleryDetails);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(LrndesignGalleryDetails).apply(this, arguments));
    }

    babelHelpers.createClass(LrndesignGalleryDetails, [{
      key: "connectedCallback",

      /**
       * life cycle, element is afixed to the DOM
       */
      value: function connectedCallback() {
        babelHelpers.get(babelHelpers.getPrototypeOf(LrndesignGalleryDetails.prototype), "connectedCallback", this).call(this);

        this._detailsChanged();
      }
      /**
       * updates the details
       *
       * @param {details} the details to be updated
       */

    }, {
      key: "_detailsChanged",
      value: function _detailsChanged() {
        this.$.details.innerHTML = this.details;
      }
    }], [{
      key: "tag",

      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */
      get: function get() {
        return "lrndesign-gallery-details";
      } // render function

    }, {
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_e90846b0e53211e9a0cfefb808989d41());
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * image's details in as a string of HTML
           */
          details: {
            type: String,
            value: null,
            observer: "_detailsChanged"
          }
        };
      }
    }]);
    return LrndesignGalleryDetails;
  }(_polymerElement.PolymerElement);

  _exports.LrndesignGalleryDetails = LrndesignGalleryDetails;
  window.customElements.define(LrndesignGalleryDetails.tag, LrndesignGalleryDetails);
});