define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/iron-a11y-keys/iron-a11y-keys.js", "../../../@polymer/paper-icon-button/paper-icon-button.js", "./mtz-marked-control-behavior.js"], function (_exports, _polymerElement, _ironA11yKeys, _paperIconButton, _mtzMarkedControlBehavior) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.MtzMarkedControlLink = void 0;

  function _templateObject_ec147540e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: inline-block;\n        }\n      </style>\n\n      <paper-icon-button\n        icon=\"[[icon]]\"\n        noink=\"[[noink]]\"\n        on-click=\"_handleCommand\"\n        alt=\"[[title]]\"\n      ></paper-icon-button>\n\n      <iron-a11y-keys\n        keys=\"[[keys]]\"\n        on-keys-pressed=\"_handleCommand\"\n        target=\"[[__editor]]\"\n      ></iron-a11y-keys>\n    "]);

    _templateObject_ec147540e53211e9a0cfefb808989d41 = function _templateObject_ec147540e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  var MtzMarkedControlLink =
  /*#__PURE__*/
  function (_mtzMarkedControlBeha) {
    babelHelpers.inherits(MtzMarkedControlLink, _mtzMarkedControlBeha);

    function MtzMarkedControlLink() {
      babelHelpers.classCallCheck(this, MtzMarkedControlLink);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(MtzMarkedControlLink).apply(this, arguments));
    }

    babelHelpers.createClass(MtzMarkedControlLink, [{
      key: "_handleCommand",

      /**
       * Toggles a syntax prefix at the start of selected lines
       *
       * @param {MouseEvent|KeyboardEvent} event
       * @protected
       */
      value: function _handleCommand(event) {
        event.preventDefault();
        event.stopPropagation();
        var editor = this.__editor;
        var selection = editor.getSelection();
        var regex = new RegExp("\\[(.*)\\]\\((.*)\\)"); // Check if syntax is present (regex)

        var matches = selection.text.match(regex);
        var text;
        var link;

        if (matches) {
          text = matches[1];
          link = matches[2];
          var match = link || text;
          editor.replaceSelection(match);
          editor.setSelection(selection.start, selection.end - (selection.length - match.length));
        } else {
          if (this._isLink(selection)) {
            text = prompt("What text would you like to display?");
            if (!text) return;
            link = selection.text;
          } else {
            link = prompt("What link would you like to use?");
            if (!link) return;
            text = selection.text;
          }

          if (link.startsWith("http://")) {
            alert("Links must be https://");
            return;
          }

          var newLink = regex[Symbol.replace]("[]()", "[".concat(text, "](").concat(link, ")"));
          editor.replaceSelection(newLink);
          editor.setSelection(selection.start, selection.end + (newLink.length - selection.length));
        }
      }
      /**
       * Determines if the selection is a link, may override for more complex checks
       *
       * @param {Object} selection - the selection from the editor
       * @return {Boolean}
       * @protected
       */

    }, {
      key: "_isLink",
      value: function _isLink(selection) {
        return selection.text.startsWith("https://");
      }
    }], [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_ec147540e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "mtz-marked-control-link";
      }
    }, {
      key: "properties",
      get: function get() {
        var props = {
          title: String,
          icon: String,
          keys: String,
          noink: Boolean // Pass-through

        };

        if (babelHelpers.get(babelHelpers.getPrototypeOf(MtzMarkedControlLink), "properties", this)) {
          props = Object.assign(props, babelHelpers.get(babelHelpers.getPrototypeOf(MtzMarkedControlLink), "properties", this));
        }

        return props;
      }
    }]);
    return MtzMarkedControlLink;
  }((0, _mtzMarkedControlBehavior.mtzMarkedControlBehavior)(_polymerElement.PolymerElement));

  _exports.MtzMarkedControlLink = MtzMarkedControlLink;
  window.customElements.define(MtzMarkedControlLink.tag, MtzMarkedControlLink);
});