define(["exports", "../../../@polymer/polymer/polymer-element.js"], function (_exports, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.PaperIconStepper = void 0;

  var PaperIconStepper =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(PaperIconStepper, _PolymerElement);

    function PaperIconStepper() {
      babelHelpers.classCallCheck(this, PaperIconStepper);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(PaperIconStepper).apply(this, arguments));
    }

    babelHelpers.createClass(PaperIconStepper, [{
      key: "previous",

      /**
       * Goes back one step
       */
      value: function previous() {
        //XXX: Multi selector does not offer selectPrevious() function
        if (this._selected < 0) {
          // we are back to start
          return;
        } // remove the currently selected from the array


        var index = this.selectedValues.indexOf(this._selected);
        this.splice("selectedValues", index, 1);
        this._selected--;
      }
      /**
       * Goes forward one step
       */

    }, {
      key: "next",
      value: function next() {
        //XXX: Multi selector does not offer selectNext() function
        if (this._selected === this._items.length - 1) {
          // We reached the end
          return;
        }

        if (this._selected >= 0) {
          this._selected++;
        } else if (this.selectedValues.length <= 0) {
          // no items selected yet
          this._selected = 0;
        } else {
          // items selected (e.g. specified by the caller). Default to the element after the last element of the array
          this._selected = this.selectedValues[this.selectedValues.length]++;
        }

        this.push("selectedValues", this._selected);
      }
      /**
       * Clears all the steps
       */

    }, {
      key: "clear",
      value: function clear() {
        this.selectedValues = [];
        this._selected = -1;
      }
    }, {
      key: "_onItemsChanged",
      value: function _onItemsChanged(e) {
        this._items = this.$.selector.items;
      }
    }], [{
      key: "tag",
      get: function get() {
        return "paper-icon-stepper";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * Indeces of the steps already selected
           */
          selectedValues: {
            type: Array,
            notify: true,
            value: []
          },

          /**
           * Currently selected step
           */
          _selected: {
            type: Number,
            value: -1
          }
        };
      }
    }]);
    return PaperIconStepper;
  }(_polymerElement.PolymerElement);

  _exports.PaperIconStepper = PaperIconStepper;
  window.customElements.define(PaperIconStepper.tag, PaperIconStepper);
});