define(["exports", "../../../@polymer/polymer/polymer-element.js"], function (_exports, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ResponsiveGridCol = void 0;

  function _templateObject_f369e640e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          position: relative;\n          min-height: 1px;\n          float: left;\n        }\n        :host:after {\n          clear: both;\n        }\n        #col-inner {\n          padding-left: 15px;\n          padding-right: 15px;\n          @apply --responsive-grid-col-inner;\n        }\n        /* Hide Print-Only on Screen */\n        @media screen {\n          :host([print-only]) {\n            display: none;\n          }\n        }\n        /* Hide Screen-Only on Print */\n        @media print {\n          :host([screen-only]) {\n            display: none;\n          }\n        }\n      </style>\n      <div id=\"col-inner\"><slot></slot></div>\n    "]);

    _templateObject_f369e640e53211e9a0cfefb808989d41 = function _templateObject_f369e640e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**    
  `responsive-grid-col`
  A column for the responsive grid
  
  * @demo demo/index.html
  
  @microcopy - the mental model for this element
    Example: 
    <responsive-grid-col 
      xs="1"    //the number of columns on an extra-small-width screen
      md="2"    //the number of columns on a small-width screen
      lg="3"    //the number of columns on a medium-width screen
      xl="4">   //the number of columns on a large-width screen
      CONTENT HERE
    </responsive-grid-col>
  
  */
  var ResponsiveGridCol =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(ResponsiveGridCol, _PolymerElement);

    function ResponsiveGridCol() {
      babelHelpers.classCallCheck(this, ResponsiveGridCol);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(ResponsiveGridCol).apply(this, arguments));
    }

    babelHelpers.createClass(ResponsiveGridCol, null, [{
      key: "template",
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_f369e640e53211e9a0cfefb808989d41());
      }
    }, {
      key: "tag",
      get: function get() {
        return "responsive-grid-col";
      }
    }, {
      key: "properties",
      get: function get() {
        return {
          /**
           * the width when viewed on an extra large screen
           */
          xl: {
            type: Number,
            value: 1
          },

          /**
           * the width when viewed on a large screen
           */
          lg: {
            type: Number,
            value: 1
          },

          /**
           * the width when viewed on a medium screen
           */
          md: {
            type: Number,
            value: 1
          },

          /**
           * the width when viewed on a small screen
           */
          sm: {
            type: Number,
            value: 1
          },

          /**
           * the width when viewed on an extra-small screen
           */
          xs: {
            type: Number,
            value: 1
          }
        };
      }
    }]);
    return ResponsiveGridCol;
  }(_polymerElement.PolymerElement);

  _exports.ResponsiveGridCol = ResponsiveGridCol;
  window.customElements.define(ResponsiveGridCol.tag, ResponsiveGridCol);
});