define(["exports", "../../@polymer/polymer/polymer-element.js", "../../@polymer/paper-icon-button/paper-icon-button.js", "../../@polymer/paper-tooltip/paper-tooltip.js", "../../@polymer/iron-icons/iron-icons.js"], function (_exports, _polymerElement, _paperIconButton, _paperTooltip, _ironIcons) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ScrollButton = void 0;

  function _templateObject_c24ecb20e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n      <style>\n        :host {\n          display: block;\n          --scroll-button-z-index: 99;\n          z-index: var(--scroll-button-z-index);\n        }\n\n        :host([hidden]) {\n          display: none;\n        }\n        paper-icon-button {\n          background-color: rgba(0, 0, 0, 0.6);\n          color: white;\n          @apply --scroll-button-button;\n        }\n        paper-icon-button:hover,\n        paper-icon-button:active,\n        paper-icon-button:focus {\n          background-color: rgba(0, 0, 0, 1);\n          @apply --scroll-button-button-active;\n        }\n        paper-tooltip {\n          --paper-tooltip-background: #000000;\n          --paper-tooltip-opacity: 1;\n          --paper-tooltip-text-color: #ffffff;\n          --paper-tooltip-delay-in: 0;\n          --paper-tooltip: {\n            border-radius: 0;\n          }\n          @apply --scroll-button-tooltip;\n        }\n      </style>\n      <paper-icon-button\n        id=\"btn\"\n        icon=\"[[icon]]\"\n        title=\"[[label]]\"\n      ></paper-icon-button>\n      <paper-tooltip for=\"btn\" position=\"[[position]]\" offset=\"14\">\n        [[label]]\n      </paper-tooltip>\n    "]);

    _templateObject_c24ecb20e53211e9a0cfefb808989d41 = function _templateObject_c24ecb20e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
   * `scroll-button`
   * `button to scroll to an area or back to top`
   *
   * @microcopy - language worth noting:
   *  -
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  var ScrollButton =
  /*#__PURE__*/
  function (_PolymerElement) {
    babelHelpers.inherits(ScrollButton, _PolymerElement);

    function ScrollButton() {
      babelHelpers.classCallCheck(this, ScrollButton);
      return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(ScrollButton).apply(this, arguments));
    }

    babelHelpers.createClass(ScrollButton, [{
      key: "connectedCallback",

      /**
       * life cycle, element is afixed to the DOM
       */
      value: function connectedCallback() {
        var _this = this;

        babelHelpers.get(babelHelpers.getPrototypeOf(ScrollButton.prototype), "connectedCallback", this).call(this);
        this.$.btn.addEventListener("click", function (e) {
          if (_this.target) {
            _this.target.scrollIntoView({
              behavior: "smooth",
              block: "end",
              inline: "nearest"
            });
          } else {
            window.scrollTo({
              top: 0,
              left: 0,
              behavior: "smooth"
            });
          }
        });
      }
      /**
       * life cycle, element is removed from the DOM
       */

    }, {
      key: "disconnectedCallback",
      value: function disconnectedCallback() {
        var _this2 = this;

        this.$.btn.removeEventListener("click", function (e) {
          if (_this2.target) {
            _this2.target.scrollIntoView({
              behavior: "smooth",
              block: "end",
              inline: "nearest"
            });
          } else {
            window.scrollTo({
              top: 0,
              left: 0,
              behavior: "smooth"
            });
          }
        });
        babelHelpers.get(babelHelpers.getPrototypeOf(ScrollButton.prototype), "disconnectedCallback", this).call(this);
      }
    }], [{
      key: "template",
      // render function
      get: function get() {
        return (0, _polymerElement.html)(_templateObject_c24ecb20e53211e9a0cfefb808989d41());
      } // haxProperty definition

    }, {
      key: "haxProperties",
      get: function get() {
        return {
          canScale: true,
          canPosition: true,
          canEditSource: false,
          gizmo: {
            title: "Scroll button",
            description: "button to scroll to an area or back to top",
            icon: "icons:android",
            color: "green",
            groups: ["Button"],
            handles: [{
              type: "todo:read-the-docs-for-usage"
            }],
            meta: {
              author: "btopro",
              owner: "The Pennsylvania State University"
            }
          },
          settings: {
            quick: [],
            configure: [{
              property: "target",
              description: "",
              inputMethod: "array",
              required: false,
              icon: "icons:android"
            }, {
              property: "icon",
              description: "",
              inputMethod: "textfield",
              required: false,
              icon: "icons:android"
            }, {
              property: "label",
              description: "",
              inputMethod: "textfield",
              required: false,
              icon: "icons:android"
            }],
            advanced: []
          }
        };
      } // properties available to the custom element for data binding

    }, {
      key: "properties",
      get: function get() {
        var props = {
          target: {
            name: "target",
            type: Object
          },
          icon: {
            name: "icon",
            type: String,
            value: "icons:expand-less"
          },
          label: {
            name: "label",
            type: String,
            value: "Scroll to top"
          },
          position: {
            name: "position",
            type: String,
            value: "top"
          }
        };

        if (babelHelpers.get(babelHelpers.getPrototypeOf(ScrollButton), "properties", this)) {
          props = Object.assign(props, babelHelpers.get(babelHelpers.getPrototypeOf(ScrollButton), "properties", this));
        }

        return props;
      }
      /**
       * Store the tag name to make it easier to obtain directly.
       * @notice function name must be here for tooling to operate correctly
       */

    }, {
      key: "tag",
      get: function get() {
        return "scroll-button";
      }
    }]);
    return ScrollButton;
  }(_polymerElement.PolymerElement);

  _exports.ScrollButton = ScrollButton;
  window.customElements.define(ScrollButton.tag, ScrollButton);
});