define(["../polymer/polymer-legacy.js", "../paper-styles/default-theme.js", "../iron-menu-behavior/iron-menu-behavior.js", "../polymer/lib/legacy/polymer-fn.js", "../polymer/lib/utils/html-tag.js"], function (_polymerLegacy, _defaultTheme, _ironMenuBehavior, _polymerFn, _htmlTag) {
  "use strict";

  function _templateObject_81b48e10e53211e9a0cfefb808989d41() {
    var data = babelHelpers.taggedTemplateLiteral(["\n    <style>\n      :host {\n        display: block;\n        padding: 8px 0;\n\n        background: var(--paper-listbox-background-color, var(--primary-background-color));\n        color: var(--paper-listbox-color, var(--primary-text-color));\n\n        @apply --paper-listbox;\n      }\n    </style>\n\n    <slot></slot>\n"]);

    _templateObject_81b48e10e53211e9a0cfefb808989d41 = function _templateObject_81b48e10e53211e9a0cfefb808989d41() {
      return data;
    };

    return data;
  }

  /**
  Material design:
  [Menus](https://www.google.com/design/spec/components/menus.html)
  
  `<paper-listbox>` implements an accessible listbox control with Material Design
  styling. The focused item is highlighted, and the selected item has bolded text.
  
      <paper-listbox>
        <paper-item>Item 1</paper-item>
        <paper-item>Item 2</paper-item>
      </paper-listbox>
  
  An initial selection can be specified with the `selected` attribute.
  
      <paper-listbox selected="0">
        <paper-item>Item 1</paper-item>
        <paper-item>Item 2</paper-item>
      </paper-listbox>
  
  Make a multi-select listbox with the `multi` attribute. Items in a multi-select
  listbox can be deselected, and multiple item can be selected.
  
      <paper-listbox multi>
        <paper-item>Item 1</paper-item>
        <paper-item>Item 2</paper-item>
      </paper-listbox>
  
  ### Styling
  
  The following custom properties and mixins are available for styling:
  
  Custom property | Description | Default
  ----------------|-------------|----------
  `--paper-listbox-background-color`   | Menu background color |
  `--primary-background-color`
  `--paper-listbox-color`              | Menu foreground color |
  `--primary-text-color`
  `--paper-listbox`                    | Mixin applied to the listbox | `{}`
  
  ### Accessibility
  
  `<paper-listbox>` has `role="listbox"` by default. A multi-select listbox will
  also have `aria-multiselectable` set. It implements key bindings to navigate
  through the listbox with the up and down arrow keys, esc to exit the listbox,
  and enter to activate a listbox item. Typing the first letter of a listbox item
  will also focus it.
  
  @group Paper Elements
  @element paper-listbox
  @demo demo/index.html
  */
  (0, _polymerFn.Polymer)({
    _template: (0, _htmlTag.html)(_templateObject_81b48e10e53211e9a0cfefb808989d41()),
    is: 'paper-listbox',
    behaviors: [_ironMenuBehavior.IronMenuBehavior],

    /** @private */
    hostAttributes: {
      role: 'listbox'
    }
  });
});