define(["exports"], function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.FilterMixin = void 0;

  /**
  @license
  Copyright (c) 2017 Vaadin Ltd.
  This program is available under Apache License Version 2.0, available at https://vaadin.com/license/
  */

  /**
   * @polymerMixin
   */
  var FilterMixin = function FilterMixin(superClass) {
    return (
      /*#__PURE__*/
      function (_superClass) {
        babelHelpers.inherits(FilterMixin, _superClass);

        function FilterMixin() {
          babelHelpers.classCallCheck(this, FilterMixin);
          return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(FilterMixin).apply(this, arguments));
        }

        babelHelpers.createClass(FilterMixin, [{
          key: "ready",
          value: function ready() {
            babelHelpers.get(babelHelpers.getPrototypeOf(FilterMixin.prototype), "ready", this).call(this);
            this.addEventListener('filter-changed', this._filterChanged.bind(this));
          }
        }, {
          key: "_filterChanged",
          value: function _filterChanged(e) {
            if (this._filters.indexOf(e.target) === -1) {
              this._filters.push(e.target);
            }

            e.stopPropagation();

            if (this.dataProvider) {
              this.clearCache();
            }
          }
        }, {
          key: "_mapFilters",
          value: function _mapFilters() {
            return this._filters.map(function (filter) {
              return {
                path: filter.path,
                value: filter.value
              };
            });
          }
        }], [{
          key: "properties",
          get: function get() {
            return {
              _filters: {
                type: Array,
                value: function value() {
                  return [];
                }
              }
            };
          }
        }]);
        return FilterMixin;
      }(superClass)
    );
  };

  _exports.FilterMixin = FilterMixin;
});