define(["exports"], function (_exports) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ThemePropertyMixin = void 0;

  /**
   * @polymerMixin
   */
  var ThemePropertyMixin = function ThemePropertyMixin(superClass) {
    return (
      /*#__PURE__*/
      function (_superClass) {
        babelHelpers.inherits(VaadinThemePropertyMixin, _superClass);

        function VaadinThemePropertyMixin() {
          babelHelpers.classCallCheck(this, VaadinThemePropertyMixin);
          return babelHelpers.possibleConstructorReturn(this, babelHelpers.getPrototypeOf(VaadinThemePropertyMixin).apply(this, arguments));
        }

        babelHelpers.createClass(VaadinThemePropertyMixin, [{
          key: "attributeChangedCallback",

          /** @protected */
          value: function attributeChangedCallback(name, oldValue, newValue) {
            babelHelpers.get(babelHelpers.getPrototypeOf(VaadinThemePropertyMixin.prototype), "attributeChangedCallback", this).call(this, name, oldValue, newValue);

            if (name === 'theme') {
              this._setTheme(newValue);
            }
          }
        }], [{
          key: "properties",
          get: function get() {
            return {
              /**
               * Helper property with theme attribute value facilitating propagation
               * in shadow DOM. Allows using `theme$="[[theme]]"` in the template.
               *
               * @protected
               */
              theme: {
                type: String,
                readOnly: true
              }
            };
          }
        }]);
        return VaadinThemePropertyMixin;
      }(superClass)
    );
  };

  _exports.ThemePropertyMixin = ThemePropertyMixin;
});