define(["exports","require","../../@polymer/polymer/polymer-element.js","../../@polymer/polymer/lib/utils/render-status.js","../schema-behaviors/schema-behaviors.js","../../@polymer/iron-a11y-keys/iron-a11y-keys.js"],function(_exports,_require,_polymerElement,_renderStatus,_schemaBehaviors,_ironA11yKeys){Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.A11yGifPlayer=void 0,_require=babelHelpers.interopRequireWildcard(_require);class A11yGifPlayer extends((0,_schemaBehaviors.SchemaBehaviors)(_polymerElement.PolymerElement)){constructor(){super(),new Promise((res,rej)=>_require.default(["../../@polymer/iron-image/iron-image.js"],res,rej))}static get template(){return _polymerElement.html`
      <style>
        :host {
          display: block;
        }
        :host #gifbutton > * {
          position: relative;
        }
        :host #svg {
          position: absolute;
          top: 35%;
          left: 35%;
        }
        :host #gifbutton:active,
        :host #gifbutton:focus,
        :host #gifbutton:hover {
          cursor: pointer;
          outline: 1px solid blue;
        }
        :host #preload {
          display: none;
        }
      </style>
      <div id="gifbutton" aria-role="button" aria-controls="gif" tabindex="0">
        <div>
          <img
            id="gif"
            alt\$="[[alt]]"
            src\$="[[srcWithoutAnimation]]"
            style="width:100%;height:100%;"
          />
          <svg
            id="svg"
            xmlns="http://www.w3.org/2000/svg"
            viewBox="0 0 200 200"
            width="30%"
            height="30%"
          >
            <g opacity=".5">
              <polygon
                points="30,20 30,180 170,100"
                fill="#000000"
                stroke="#ffffff"
                stroke-width="15px"
              ></polygon>
              <text x="50" y="115" fill="#ffffff" font-size="40px">GIF</text>
            </g>
          </svg>
        </div>
      </div>
      <iron-image id="preload" src\$="[[src]]" hidden=""></iron-image>
      <iron-a11y-keys
        id="a11y"
        keys="enter space"
        on-keys-pressed="toggleAnimation"
      ></iron-a11y-keys>
    `}static get tag(){return"a11y-gif-player"}static get properties(){let props={src:{type:String,value:null},srcWithoutAnimation:{type:String,value:null},alt:{type:String,value:null}};return super.properties&&(props=Object.assign(props,super.properties)),props}connectedCallback(){super.connectedCallback(),(0,_renderStatus.afterNextRender)(this,function(){this.addEventListener("click",this.toggleAnimation.bind(this))})}disconnectedCallback(){this.removeEventListener("click",this.toggleAnimation.bind(this)),super.disconnectedCallback()}ready(){super.ready(),this.stop(),this.shadowRoot.querySelector("#a11y").target=this.shadowRoot.querySelector("#gifbutton")}play(){this.__stopped=!0,this.toggleAnimation()}stop(){this.__stopped=!1,this.toggleAnimation()}toggleAnimation(){this.__stopped?(this.__stopped=!1,this.shadowRoot.querySelector("#svg").style.visibility="hidden",null!=this.src&&(this.shadowRoot.querySelector("#gif").src=this.src),this.shadowRoot.querySelector("#gif").alt=this.alt+" (Stop animation.)"):(this.__stopped=!0,this.shadowRoot.querySelector("#svg").style.visibility="visible",null!=this.srcWithoutAnimation&&(this.shadowRoot.querySelector("#gif").src=this.srcWithoutAnimation),this.shadowRoot.querySelector("#gif").alt=this.alt+" (Play animation.)")}static get haxProperties(){return{canScale:!0,canPosition:!0,canEditSource:!1,gizmo:{title:"Accessible GIF",description:"Makes animated GIFs accessible.",icon:"gif",color:"grey",groups:["Images","Media"],handles:[{type:"image",source:"src",source2:"srcWithoutAnimation",alt:"alt"}],meta:{author:"LRNWebComponents"}},settings:{quick:[{property:"src",title:"Animated GIF",description:"The URL to your animated GIF.",inputMethod:"textfield",icon:"link",validationType:"url",required:!0},{property:"srcWithoutAnimation",title:"Still Image",description:"The URL to a still image version of your GIF.",inputMethod:"textfield",icon:"link",validationType:"url",required:!0},{property:"alt",title:"Alt Text",description:"Alternative text for the image.",inputMethod:"textfield",icon:"accessibility",required:!0}],configure:[{property:"src",title:"Animated GIF",description:"The URL to your animated GIF.",inputMethod:"haxupload",icon:"link",validationType:"url",required:!0},{property:"srcWithoutAnimation",title:"Still Image",description:"The URL to a still image version of your GIF.",inputMethod:"haxupload",icon:"link",validationType:"url",required:!0},{property:"alt",title:"Alt Text",description:"Alternative text for the image.",inputMethod:"alt",icon:"accessibility",required:!0}],advanced:[]}}}}_exports.A11yGifPlayer=A11yGifPlayer,window.customElements.define(A11yGifPlayer.tag,A11yGifPlayer)});