define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/paper-button/paper-button.js", "../../../../@polymer/iron-icon/iron-icon.js"], function (_exports, _polymerElement, _paperButton, _ironIcon) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.ElmsmediaDashboardToolbarButton = void 0;

  class ElmsmediaDashboardToolbarButton extends _polymerElement.PolymerElement {
    static get template() {
      return _polymerElement.html`
      <style>
        :host {
          display: flex;
          align-items: center;
          justify-content: center;
          opacity: 0.7;
        }
        #title {
          font-size: 1em;
          margin: 0;
          margin-right: 0.3em;
          padding: 0;
        }
      </style>
      <paper-button id="button">
        <h3 id="title">[[title]]</h3>
        <iron-icon id="icon" icon="[[icon]]"></iron-icon>
      </paper-button>
    `;
    }

    static get tag() {
      return "elmsmedia-dashboard-toolbar-button";
    }

    static get properties() {
      return {
        title: {
          type: String,
          value: ""
        },
        icon: {
          type: String,
          value: ""
        }
      };
    }

  }

  _exports.ElmsmediaDashboardToolbarButton = ElmsmediaDashboardToolbarButton;
  window.customElements.define(ElmsmediaDashboardToolbarButton.tag, ElmsmediaDashboardToolbarButton);
});