define(["exports", "../../../../@polymer/polymer/polymer-element.js", "../../../../@polymer/iron-image/iron-image.js", "./lrnapp-studio-submission-media-editoverlay.js"], function (_exports, _polymerElement, _ironImage, _lrnappStudioSubmissionMediaEditoverlay) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnappStudioSubmissionEditImage = void 0;

  class LrnappStudioSubmissionEditImage extends _polymerElement.PolymerElement {
    static get template() {
      return _polymerElement.html`
      <custom-style>
        <style is="custom-style">
          :host {
            display: inline-flex;
            justify-content: space-around;
            min-height: 100px;
            position: relative;
          }

          iron-image {
            --iron-image-height: 200px;
            display: block;
          }
        </style>
      </custom-style>
      <lrnapp-studio-submission-media-editoverlay
        data-index\$="[[index]]"
        embedcode="{{embedcode}}"
      >
        <iron-image
          src="[[thumbnail]]"
          style="width:200px; height:200px; background-color: lightgray;"
          sizing="contain"
          class="contain"
          preload=""
          fade=""
        ></iron-image>
      </lrnapp-studio-submission-media-editoverlay>
    `;
    }

    static get tag() {
      return "lrnapp-studio-submission-edit-image";
    }

    static get properties() {
      return {
        image: {
          type: Object,
          notify: true
        },
        thumbnail: {
          type: String,
          notify: true,
          computed: "_getThumbnail(image)"
        },
        embedcode: {
          type: String,
          computed: "_computeEmbedCode(image)"
        }
      };
    }

    _getThumbnail(image) {
      return image.url;
    }

    _computeEmbedCode(image) {
      return "![Alternative Text Here](" + image.url + ")";
    }

  }

  _exports.LrnappStudioSubmissionEditImage = LrnappStudioSubmissionEditImage;
  window.customElements.define(LrnappStudioSubmissionEditImage.tag, LrnappStudioSubmissionEditImage);
});