define(["exports", "require", "../../../../../@polymer/polymer/polymer-element.js"], function (_exports, _require, _polymerElement) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.Minimalist = _exports.MinimalistTemplate = void 0;
  _require = babelHelpers.interopRequireWildcard(_require);

  /**
   * Copyright 2019 The Pennsylvania State University
   * @license Apache-2.0, see License.md for full text.
   */

  /**
   * `An incredibly minimalist template.
   * @HTMLElement
   */
  let MinimalistTemplate = superclass => class extends superclass {
    constructor() {
      super();
      new Promise((res, rej) => _require.default(["../../../../scroll-button/scroll-button.js"], res, rej));
      new Promise((res, rej) => _require.default(["../active-item/site-active-title.js"], res, rej));
      new Promise((res, rej) => _require.default(["../active-item/site-active-fields.js"], res, rej));
      new Promise((res, rej) => _require.default(["../blocks/site-children-block.js"], res, rej));
      new Promise((res, rej) => _require.default(["../layout/site-footer.js"], res, rej));
      new Promise((res, rej) => _require.default(["../layout/site-modal.js"], res, rej));
      new Promise((res, rej) => _require.default(["../navigation/site-breadcrumb.js"], res, rej));
      new Promise((res, rej) => _require.default(["../navigation/site-top-menu.js"], res, rej));
      new Promise((res, rej) => _require.default(["../navigation/site-menu-button.js"], res, rej));
      new Promise((res, rej) => _require.default(["../navigation/site-menu.js"], res, rej));
      new Promise((res, rej) => _require.default(["../site/site-rss-button.js"], res, rej));
      new Promise((res, rej) => _require.default(["../site/site-print-button.js"], res, rej));
      new Promise((res, rej) => _require.default(["../site/site-title.js"], res, rej));
    } // render function


    static get template() {
      return _polymerElement.html`
        <site-top-menu
          noink
          notitle
          showindex
          sticky
          conditions='{"parent": "$firstId"}'
        >
          <div slot="prefix" class="spacing">
            <site-title icon="home" notitle></site-title>
          </div>
          <div slot="prefix" class="spacing">
            <site-print-button></site-print-button>
          </div>
        </site-top-menu>
        <site-active-fields fields="{{activeItemFields}}"></site-active-fields>
        <header
          class="masthead"
          style$="background-image: url('[[activeItemFields.images.0.src]]');"
          alt$="[[activeItemFields.images.0.alt]]"
        >
          <div class="overlay"></div>
          <div class="container">
            <div class="row">
              <div class="col-lg-10 col-md-10 mx-auto">
                <div class="page-heading">
                  <h1>[[activeItemFields.title]]</h1>
                  <h2>[[activeItemFields.subtitle]]</h2>
                  <span class="subheading"></span>
                </div>
              </div>
            </div>
          </div>
        </header>
        <div class="container">
          <div id="contentcontainer">
            <div id="slot"><slot></slot></div>
          </div>
        </div>
        <hr />
        <site-top-menu
          noink
          notitle
          indicator="none"
          position="top"
          showindex
          conditions='{"parent": "$firstId"}'
        >
          <div slot="prefix" class="spacing">
            <site-title icon="home" notitle position="top"></site-title>
          </div>
          <div slot="prefix" class="spacing">
            <site-print-button position="top"></site-print-button>
          </div>
          <div slot="prefix" class="spacing">
            <site-menu-button type="prev" position="top"></site-menu-button>
          </div>
          <div slot="suffix" class="spacing">
            <site-menu-button type="next" position="top"></site-menu-button>
          </div>
        </site-top-menu>
        <hr />
        <site-footer></site-footer>
        <scroll-button position="right" label="Back to top"> </scroll-button>
      `;
    }

  };

  _exports.MinimalistTemplate = MinimalistTemplate;

  class Minimalist extends MinimalistTemplate(HTMLElement) {}

  _exports.Minimalist = Minimalist;
  window.customElements.define("minimalist-template", Minimalist);
});