define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/iron-a11y-keys/iron-a11y-keys.js", "../../relative-heading/relative-heading.js"], function (_exports, _polymerElement, _ironA11yKeys, _relativeHeading) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrndesignImagemapHotspot = void 0;

  /**
   * `lrndesign-imagemap-hotspot`
   * creates an accessible image map
   *
   * @customElement
   * @polymer
   * @demo demo/index.html
   */
  class LrndesignImagemapHotspot extends _polymerElement.PolymerElement {
    static get template() {
      return _polymerElement.html`
      <style>
        :host {
          display: none;
        }
        :host #desc {
          margin: 0 0 15px;
        }
        @media print {
          :host {
            display: block;
          }
        }
      </style>
      <relative-heading hidden\$="[[!label]]" id="heading" text\$="[[label]]">
      </relative-heading>
      <div id="desc"><slot></slot></div>
    `;
    }

    static get tag() {
      return "lrndesign-imagemap-hotspot";
    }

    static get properties() {
      return {
        /**
         * Label for the hotspot
         */
        label: {
          type: String,
          value: null
        },

        /**
         * Id of hotspot element inside the SVG
         */
        hotspotId: {
          type: String,
          value: null
        }
      };
    }

    setParentHeading(parent) {
      this.$.heading._setParent(parent);
    }

  }

  _exports.LrndesignImagemapHotspot = LrndesignImagemapHotspot;
  window.customElements.define(LrndesignImagemapHotspot.tag, LrndesignImagemapHotspot);
});