define(["exports", "../../../@polymer/polymer/polymer-element.js", "../../../@polymer/app-layout/app-layout.js", "../../paper-avatar/paper-avatar.js", "../../lrn-icons/lrn-icons.js", "../../../@polymer/polymer/lib/elements/dom-repeat.js", "../../../@polymer/paper-button/paper-button.js", "../../simple-colors/simple-colors.js", "../../../@polymer/iron-icons/iron-icons.js", "../../../@polymer/iron-collapse/iron-collapse.js", "./lrnsys-collapselist-item.js"], function (_exports, _polymerElement, _appLayout, _paperAvatar, _lrnIcons, _domRepeat, _paperButton, _simpleColors, _ironIcons, _ironCollapse, _lrnsysCollapselistItem) {
  "use strict";

  Object.defineProperty(_exports, "__esModule", {
    value: true
  });
  _exports.LrnsysCollapselist = void 0;

  /**
   * `lrnsys-collapselist`
   */
  class LrnsysCollapselist extends _polymerElement.PolymerElement {
    static get template() {
      return _polymerElement.html`
      <style include="simple-colors-shared-styles">
        :host {
          display: block;
          background-color: var(--simple-colors-background1);
          --lrnsys-collapselist-text-color: var(--simple-colors-foreground1);
          --lrnsys-collapselist-item-color: var(--simple-colors-background1);
          --lrnsys-collapselist-item-active-color: var(
            --simple-colors-background2
          );
          --lrnsys-collapselist-item-border: var(--simple-colors-background5);
        }
        ul {
          list-style-type: none;
          margin: 0;
          padding: 0;
        }
        ul li {
          width: 100%;
          border: 1px solid var(--lrnsys-collapselist-item-border);
          margin-bottom: -1px;
        }
        ul li paper-button {
          height: 32px;
          padding: 8px;
          margin: 0;
          min-width: 0.16px;
          -webkit-justify-content: flex-start;
          justify-content: flex-start;
          align-items: center;
          width: 100%;
          text-transform: unset;
          border-radius: 0;
        }
        ul li paper-button iron-icon,
        ul li paper-button span {
          pointer-events: none;
        }
        iron-icon {
          display: inline-block;
        }
        .collapse-label {
          margin-left: 8px;
        }
        .collapse-content {
          padding: 16px;
        }
      </style>
      <ul>
        <template is="dom-repeat" items="[[items]]" as="row">
          <li>
            <lrnsys-collapselist-item>
              <span slot="label">
                <iron-icon icon="[[row.icon]]"></iron-icon>
                <span class="collapse-label">[[row.label]]</span>
              </span>
              <span slot="content"> [[row.content]] </span>
            </lrnsys-collapselist-item>
          </li>
        </template>
      </ul>
    `;
    }

    static get tag() {
      return "lrnsys-collapselist";
    }

    static get properties() {
      return {
        /**
         * Array of items to present with label and content for the list of collapses.
         */
        items: {
          type: Array
        }
      };
    }

  }

  _exports.LrnsysCollapselist = LrnsysCollapselist;
  window.customElements.define(LrnsysCollapselist.tag, LrnsysCollapselist);
});