import{html,PolymerElement}from"../../../@polymer/polymer/polymer-element.js";import{dom}from"../../../@polymer/polymer/lib/legacy/polymer.dom.js";import"../../../@polymer/iron-flex-layout/iron-flex-layout-classes.js";import"../../../@polymer/iron-icons/image-icons.js";import"../../../@polymer/iron-icons/iron-icons.js";import"../../../@polymer/iron-icons/editor-icons.js";import"../../../@polymer/iron-pages/iron-pages.js";import"../../../@polymer/app-layout/app-toolbar/app-toolbar.js";import"../../../@polymer/paper-menu-button/paper-menu-button.js";import"../../../@polymer/paper-icon-button/paper-icon-button.js";import"../../../@polymer/paper-ripple/paper-ripple.js";import{AppLocalizeBehavior}from"../../../@polymer/app-localize-behavior/app-localize-behavior.js";import{mixinBehaviors}from"../../../@polymer/polymer/lib/legacy/class.js";import"./eco-json-schema-object.js";import"./eco-json-schema-array.js";import"./eco-json-schema-boolean.js";import"./eco-json-schema-enum.js";import"./eco-json-schema-file.js";import"./eco-json-schema-input.js";class EcoJsonSchemaWizard extends(mixinBehaviors([AppLocalizeBehavior],PolymerElement)){static get tag(){return"eco-json-schema-wizard"}static get template(){return html`
      <style is="custom-style" include="iron-flex iron-flex-alignment">
        :host {
          display: block;
          @apply --layout-vertical;
        }

        paper-input {
          padding: 2px;
          --paper-input-container-label: {
            white-space: normal;
            position: static;
            font-size: 22px;
            color: #fff;
          }
        }

        .box,
        #form {
          display: -webkit-box;
          display: -webkit-flex;
          display: -moz-box;
          display: -ms-flexbox;
          display: flex;
          -webkit-flex-align: center;
          -ms-flex-align: center;
          -webkit-align-items: center;
          align-items: center;
        }

        .fullbleed {
          z-index: 1;
        }

        app-toolbar.bottom {
          --app-toolbar-color: var(--app-primary-color);
          --app-toolbar-background: var(--dark-theme-text-color);
        }

        app-toolbar.bottom paper-icon-button {
          --app-toolbar-color: var(--dark-theme-text-color);
          --app-toolbar-background: var(--app-primary-color);
        }
      </style>
      <div class="vertical flex layout fullbleed">
        <!--
        paper-icon-button id="camButton" icon="editor:insert-photo" raised>add photo</paper-icon-button
      -->
        <app-toolbar>
          <paper-icon-button
            id="prevButton"
            icon="arrow-back"
            hidden\$="{{!hasPrev}}"
            on-click="prev"
            raised=""
            >{{localize('prev')}}</paper-icon-button
          ><span
            class="title layout horizontal flex"
            style="white-space: normal"
            >[[title]]</span
          >
          <paper-icon-button
            id="nextButton"
            icon="arrow-forward"
            hidden\$="{{!hasNext}}"
            on-click="next"
            raised=""
            >{{localize('next')}}</paper-icon-button
          >
          <paper-icon-button
            id="submitButton"
            icon="cloud-upload"
            on-click="submit"
            raised=""
            >{{localize('submit')}}</paper-icon-button
          >
        </app-toolbar>
        <iron-pages
          id="form"
          class="layout horizontal flex start-justified"
          role="main"
          selected="[[page]]"
          attr-for-selected="name"
        ></iron-pages>
        <app-toolbar class="bottom">
          <div hidden\$="{{!hasPrev}}" on-click="prev">
            <paper-icon-button id="prevButton" icon="arrow-back" raised=""
              >{{localize('prev')}}</paper-icon-button
            >
            <span class="title layout" style="white-space: normal"
              >{{localize('prev')}}</span
            >
          </div>
          <span
            class="title layout horizontal flex"
            style="white-space: normal"
          ></span>
          <div hidden\$="{{!hasNext}}" on-click="next">
            <span class="title layout" style="white-space: normal"
              >{{localize('next')}}</span
            >
            <paper-icon-button id="nextButton" icon="arrow-forward" raised=""
              >{{localize('next')}}</paper-icon-button
            >
          </div>
        </app-toolbar>
      </div>
    `}static get properties(){return{language:{type:String,notify:!0},resources:{type:Object,notify:!0},schema:{type:Object,notify:!0,observer:"_schemaChanged"},label:{type:String},value:{type:Object,notify:!0,value:()=>({})},page:{type:String,notify:!0,observer:"_pageChanged"},pages:{type:Array,notify:!0,value:[]},error:{type:Object,observer:"_errorChanged"},isReview:{type:Boolean,value:!1,notify:!0},canSubmit:{type:Boolean,notify:!0},hasNext:{type:Boolean,notify:!0},hasPrev:{type:Boolean,notify:!0},titles:{type:Array,notify:!0,value:[]},title:{type:String,value:"",notify:!0}}}disconnectedCallback(){this._clearForm(),super.disconnectedCallback()}_buildSchemaProperties(){var ctx=this;this._schemaProperties=Object.keys(this.schema.properties||[]).map(function(key){var schema=ctx.schema.properties[key],property={property:key,label:schema.title||key,schema:schema,component:schema.component||{}};if(property.component.valueProperty||(property.component.valueProperty="value"),ctx._isSchemaEnum(schema))property.component.name=property.component.name||"eco-json-schema-enum",property.value="";else if(ctx._isSchemaBoolean(schema.type))property.component.name=property.component.name||"eco-json-schema-boolean",property.value=!1;else if(ctx._isSchemaFile(schema.type))property.component.name=property.component.name||"eco-json-schema-file",property.value="";else if(ctx._isSchemaValue(schema.type))property.component.name=property.component.name||"eco-json-schema-input",property.value="";else if(ctx._isSchemaObject(schema.type))property.component.name=property.component.name||"eco-json-schema-object",property.component.wizard=!0,property.value={};else{if(!ctx._isSchemaArray(schema.type))return console.error("Unknown property type %s",schema.type);property.component.name=property.component.name||"eco-json-schema-array",property.value=[]}return ctx.push("pages",key),ctx.push("titles",schema.title),property})}_schemaPropertyChanged(event,detail){if(!detail.path||!/\.length$/.test(detail.path)){var ctx=this,property=event.target.schemaProperty,path=["value",property.property];if(detail.path&&/\.splices$/.test(detail.path)){for(var parts=detail.path.split(".").slice(1,-1);parts.length;)path.push(parts.shift()),property.keyMap&&property.keyMap[path.join(".")]&&(path=property.keyMap[path.join(".")].split("."));detail.value.keySplices&&property.keyMap&&detail.value.keySplices.forEach(function(splice){splice.removed.forEach(function(k){delete property.keyMap[path.concat([k]).join(".")]})}),detail.value.indexSplices.forEach(function(splice){var args=[path.join("."),splice.index,splice.removed.length];if(splice.addedCount)for(var i=0,ii=splice.addedCount;i<ii;i++)splice.addedKeys&&splice.addedKeys[i]&&(property.keyMap=property.keyMap||{},property.keyMap[path.concat([splice.addedKeys[i]]).join(".")]=path.concat([i+splice.index]).join(".")),args.push(ctx._deepClone(splice.object[i+splice.index]));ctx.splice.apply(ctx,args)})}else if(detail.path){parts=detail.path.split(".").slice(1);for(this.value.hasOwnProperty(property.property)||this.set("value."+property.property,{});parts.length;){var k=parts.shift();path.push(k),property.keyMap&&property.keyMap[path.join(".")]&&(path=property.keyMap[path.join(".")].split("."))}this.set(path.join("."),this._deepClone(detail.value)),console.log("value: "+JSON.stringify(this.value))}}}_setValue(){var ctx=this,value={};this._schemaProperties.forEach(function(property){value[property.property]=ctx._deepClone(property.value)}),this.value=value}_buildForm(){var ctx=this;this._schemaProperties.forEach(property=>{var el=ctx.create(property.component.name,{label:property.label,schema:property.schema,schemaProperty:property,language:this.language,resources:this.resources});el.setAttribute("name",property.property),el.className="flex start-justified",property.value=el[property.component.valueProperty],ctx.listen(el,property.component.valueProperty.replace(/([A-Z])/g,"-$1").toLowerCase()+"-changed","_schemaPropertyChanged"),dom(ctx.$.form).appendChild(el)})}_removePropertyEl(el){void 0!==el.schemaProperty&&this.unlisten(el,el.schemaProperty.component.valueProperty.replace(/([A-Z])/g,"-$1").toLowerCase()+"-changed","_schemaPropertyChanged"),el.schemaProperty=null,dom(this.$.form).removeChild(el)}_clearForm(){for(var formEl=dom(this.$.form);formEl.firstChild;)this._removePropertyEl(formEl.firstChild)}_schemaChanged(){this._clearForm(),this._buildSchemaProperties(),this._buildForm(),this._setValue(),this.pages.length>0&&this.set("page",this.pages[0]),this.set("title",this.titles[0])}next(){var current=this.pages.indexOf(this.page),next=current;-1!==current?(current<this.pages.length-1&&(next=current+1),this.set("page",this.pages[next]),this.set("title",this.titles[next])):console.log("Invalid current page in wizard")}prev(){var current=this.pages.indexOf(this.page),prev=current;-1!==current?(current>0&&(prev=current-1),this.set("page",this.pages[prev]),this.set("title",this.titles[prev])):console.log("Invalid current page in wizard")}submit(){this.dispatchEvent(new CustomEvent("submit",{bubbles:!0,cancelable:!0,composed:!0,detail:!0}))}_pageChanged(){var current=this.pages.indexOf(this.page);0===current?this.set("hasPrev",!1):this.set("hasPrev",!0),current===this.pages.length-1?this.set("hasNext",!1):this.set("hasNext",!0)}_errorChanged(){var ctx=this;dom(this.$.form).childNodes.forEach(function(el){var name=el.getAttribute("name");ctx.error&&ctx.error[name]?el.error=ctx.error[name]:el.error=null})}_deepClone(o){return JSON.parse(JSON.stringify(o))}_isSchemaValue(type){return this._isSchemaBoolean(type)||this._isSchemaNumber(type)||this._isSchemaString(type)||this._isSchemaFile(type)}_isSchemaFile(type){return Array.isArray(type)?-1!==type.indexOf("file"):"file"===type}_isSchemaBoolean(type){return Array.isArray(type)?-1!==type.indexOf("boolean"):"boolean"===type}_isSchemaEnum(schema){return!!schema.enum}_isSchemaNumber(type){return Array.isArray(type)?-1!==type.indexOf("number")||-1!==type.indexOf("integer"):"number"===type||"integer"===type}_isSchemaString(type){return Array.isArray(type)?-1!==type.indexOf("string"):"string"===type}_isSchemaObject(type){return"object"===type}_isSchemaArray(type){return"array"===type}}window.customElements.define(EcoJsonSchemaWizard.tag,EcoJsonSchemaWizard);export{EcoJsonSchemaWizard};