import{html,PolymerElement}from"../../@polymer/polymer/polymer-element.js";import{afterNextRender}from"../../@polymer/polymer/lib/utils/render-status.js";import{pathFromUrl}from"../../@polymer/polymer/lib/utils/resolve-url.js";import"../../@polymer/paper-progress/paper-progress.js";import"./lib/lrnsys-progress-circle.js";class LrnsysProgress extends PolymerElement{static get template(){return html`
      <style include="paper-material-styles">
        :host {
          display: block;
          margin-top: 24px;
        }
        :host([size="tiny"]) {
          font-size: 12.8px;
        }
        :host([size="small"]) {
          font-size: 19.2px;
        }
        :host([size="medium"]) {
          font-size: 25.6px;
        }
        :host([size="large"]) {
          font-size: 44.8px;
        }
        :host([size="x-large"]) {
          font-size: 64px;
        }
        :host([size="epic"]) {
          font-size: 96px;
        }
        #circle-container {
          display: flex;
          justify-content: space-between;
          margin: -24px 0 0 0;
          padding: 0;
          list-style: none;
        }
        .progress-title {
          position: absolute !important;
          clip: rect(1px 1px 1px 1px); /* IE6, IE7 */
          clip: rect(1px, 1px, 1px, 1px);
          overflow: hidden;
          height: 1px;
        }
        paper-progress {
          --paper-progress-height: 8px;
          --paper-progress-transition-duration: 0.5s;
          --paper-progress-transition-timing-function: ease;
          --paper-progress-transition-delay: 0.4s;
          width: 100%;
        }
        /* required to get the box shadow above the progress bar */
        .circle-node {
          z-index: 1;
        }
        ul#circle-container li.circle-node {
          list-style-type: none;
        }

        :host([vertical]) {
          width: max-content;
        }
        :host([vertical]) #circle-container {
          display: block;
        }
        :host([vertical]) paper-progress {
          display: none !important;
        }
        :host([vertical]) lrnsys-progress-circle {
          margin: 16px 0;
          padding: 0;
          width: 100%;
        }

        lrnsys-progress-circle {
          width: 40px;
          height: 40px;
          --lrnsys-progress-circle-size: 40px;
          --lrnsys-progress-spinner-size: 32px;
          --lrnsys-progress-icon-size: 24px;
          --paper-spinner-stroke-width: 1.2px;
        }
      </style>

      <iron-ajax
        id="ajax"
        url="[[activeNodeURL]]"
        handle-as="json"
        last-error="{{nodeDataError}}"
        on-response="handleNodeResponse"
      ></iron-ajax>
      <h3 class="progress-title">[[title]]</h3>
      <paper-progress
        id="progress"
        value="[[overallPercentage]]"
      ></paper-progress>
      <ul id="circle-container">
        <template is="dom-repeat" items="[[items]]" as="item">
          <li class="circle-node">
            <lrnsys-progress-circle
              play-finish-sound="[[soundFinish]]"
              play-sound="[[sound]]"
              complete-sound="[[completeSound]]"
              finished-sound="[[finishedSound]]"
              active="[[_isActive(index, active)]]"
              step="[[index]]"
              label="[[item.title]]"
              icon="[[item.metadata.icon]]"
              icon-complete="[[item.metadata.iconComplete]]"
              data-url="[[item.metadata.dataUrl]]"
              url="[[item.location]]"
              status="[[item.metadata.status]]"
              value="[[item.metadata.value]]"
              max="[[item.metadata.max]]"
              stroke-width="[[strokeWidth]]"
              tool-tip="[[!vertical]]"
              list-view="[[vertical]]"
              class\$="[[size]]"
            >
              <span slot="description">[[item.description]]</span>
            </lrnsys-progress-circle>
          </li>
        </template>
      </ul>
    `}static get tag(){return"lrnsys-progress"}connectedCallback(){super.connectedCallback(),afterNextRender(this,function(){this.addEventListener("node-is-active",this._bubbleUpChangeActive.bind(this)),this.addEventListener("node-status-change",this._statusChanged.bind(this))})}disconnectedCallback(){this.removeEventListener("node-is-active",this._bubbleUpChangeActive.bind(this)),this.removeEventListener("node-status-change",this._statusChanged.bind(this)),super.disconnectedCallback()}static get properties(){return{disableAjaxCalls:{type:Boolean,value:!1,reflectToAttribute:!0},items:{type:Array,value:[],notify:!0,observer:"_itemsChanged"},sound:{type:Boolean,value:!1,reflectToAttribute:!0},soundFinish:{type:Boolean,value:!1,reflectToAttribute:!0},completeSound:{type:String,value:pathFromUrl(decodeURIComponent(import.meta.url))+"lib/assets/complete.mp3",reflectToAttribute:!0},finishedSound:{type:String,value:pathFromUrl(decodeURIComponent(import.meta.url))+"lib/assets/finished.mp3",reflectToAttribute:!0},title:{type:String,value:"Steps to completion",reflectToAttribute:!0},keyItems:{type:Array,value:[],notify:!0},active:{type:Number,value:0,notify:!0,reflectToAttribute:!0,observer:"_activeChanged"},progressiveUnlock:{type:Boolean,value:!0,reflectToAttribute:!0,notify:!0},state:{type:String,value:null,reflectToAttribute:!0,observer:"_reportState"},overallPercentage:{type:Number,computed:"_overallPercentageCompute(items, active)",reflectToAttribute:!0},_responseList:{type:Array,value:[]},activeNodeResponse:{type:String,value:"",observer:"_activeResponseChanged"},manifest:{type:Object,value:{},notify:!0,observer:"_manifestChanged"},nodeDataError:{type:Object,value:[],observer:"_handleNodeError"},vertical:{type:Boolean,value:!1},size:{type:String,value:"medium",notify:!0,reflectToAttribute:!0},strokeWidth:{type:Number,computed:"_getStrokeWidth(size)"}}}_getStrokeWidth(size){var width=4;return"tiny"==size?width=3:"small"==size?width=4:"medium"==size?width=5:"large"==size?width=6:"x-large"==size?width=7:"epic"==size&&(width=8),width}_reportState(newValue,oldValue){null!=newValue&&this.items.length>0&&this.dispatchEvent(new CustomEvent("progress-state-change",{bubbles:!0,cancelable:!0,composed:!0,detail:{state:this.state,active:this.items[this.active]}}))}_itemsChanged(newValue,oldValue){void 0!==oldValue&&void 0!==newValue&&newValue.length!=oldValue.length&&void 0===this._responseList[this.active]&&(newValue[this.active].metadata.status="loading",this.set("items."+this.active+".metadata.status","loading"),this.notifyPath("items."+this.active+".metadata.status"),void 0===newValue[this.active].dataUrl||this.disableAjaxCalls?setTimeout(()=>{newValue[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this._responseList[this.active]={},this.activeNodeResponse=this._responseList[this.active]},1200):(this.$.ajax.url=newValue[this.active].dataUrl,this.$.ajax.generateRequest()))}_isActive(index,active){return index===active}_activeResponseChanged(value){this.dispatchEvent(new CustomEvent("progress-response-loaded",{bubbles:!0,cancelable:!0,composed:!0,detail:{response:value}}))}_bubbleUpChangeActive(e){this.active=e.detail.target.step,this.dispatchEvent(new CustomEvent("json-outline-schema-active-item-changed",{bubbles:!0,cancelable:!0,composed:!0,detail:this.items[this.active]}))}_manifestChanged(newValue,oldValue){newValue&&(this.set("items",newValue.items),this.notifyPath("items.*"))}_activeChanged(newValue,oldValue){this.state="active item is "+this.active,this.items.forEach((element,index,array)=>{"disabled"==this.items[index].metadata.status?0!=index&&this.progressiveUnlock&&"complete"==this.items[index-1].metadata.status&&(this.items[index].metadata.status="loading",this.set("items."+index+".metadata.status","loading"),this.notifyPath("items."+index+".metadata.status")):this.items[index].metadata.value>=this.items[index].metadata.max&&index==this.items.length-1?(this.items[index].metadata.status="finished",this.set("items."+index+".metadata.status","finished"),this.notifyPath("items."+index+".metadata.status")):this.items[index].metadata.value>=this.items[index].metadata.max?(this.items[index].metadata.status="complete",this.set("items."+index+".metadata.status","complete"),this.notifyPath("items."+index+".metadata.status")):index==this.active?void 0===this._responseList[index]?(this.items[index].metadata.status="loading",this.set("items."+index+".metadata.status","loading"),this.notifyPath("items."+index+".metadata.status")):(this.activeNodeResponse=this._responseList[index],this.items[index].metadata.status="available",this.set("items."+index+".metadata.status","available"),this.notifyPath("items."+index+".metadata.status")):(this.items[index].metadata.status="available",this.set("items."+index+".metadata.status","available"),this.notifyPath("items."+index+".metadata.status"))})}_statusChanged(e){"loading"==e.target.status?void 0===this.items[this.active].metadata.dataUrl||this.disableAjaxCalls?setTimeout(()=>{this.items[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this._responseList[this.active]={},this.activeNodeResponse=this._responseList[this.active]},1500):(this.$.ajax.url=this.items[this.active].metadata.dataUrl,this.$.ajax.generateRequest()):"complete"==e.target.status&&this.items.length===this.active+1&&setTimeout(()=>{this.items[this.active].metadata.status="finished",this.set("items."+this.active+".metadata.status","finished"),this.notifyPath("items."+this.active+".metadata.status")},100)}handleNodeResponse(e){const detail=e.detail;"object"==typeof detail.response?setTimeout(()=>{this.items[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this._responseList[this.active]=detail.response,this.activeNodeResponse=this._responseList[this.active]},1500):(this.items[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this._responseList[this.active]=detail.response,this.activeNodeResponse=this._responseList[this.active])}_handleNodeError(newValue,oldValue){void 0!==oldValue&&null!=newValue&&0!=newValue.length&&(this._responseList[this.active]=newValue,this.activeNodeResponse=this._responseList[this.active],this.items[this.active].metadata.status="available",this.set("items."+this.active+".metadata.status","available"),this.notifyPath("items."+this.active+".metadata.status"),this.dispatchEvent(new CustomEvent("node-load-failed",{bubbles:!0,cancelable:!0,composed:!0,detail:this.items[this.active]})))}_overallPercentageCompute(items,active){return void 0!==items?(this.$.progress.classList.add("transiting"),active/(items.length-1)*100):0}changePercentage(percentage,mode){var newp=0;(newp="add"==mode?this.items[this.active].metadata.value+percentage:"subtract"==mode?this.items[this.active].metadata.value-percentage:percentage)>=this.items[this.active].metadata.max?(this.items.length==this.active+1?(this.state="finished",this.items[this.active].metadata.status="finished",this.set("items."+this.active+".metadata.status","finished"),this.notifyPath("items."+this.active+".metadata.status"),this.items[this.active].metadata.value=this.items[this.active].metadata.max,this.set("items."+this.active+".metadata.value",this.items[this.active].metadata.max),this.notifyPath("items."+this.active+".metadata.value")):(this.items[this.active].metadata.value=this.items[this.active].metadata.max,this.set("items."+this.active+".metadata.value",this.items[this.active].metadata.max),this.notifyPath("items."+this.active+".metadata.value")),this.items.length>this.active+1&&((this.progressiveUnlock&&"complete"==this.items[this.active].metadata.status&&"disabled"==this.items[this.active+1].metadata.status||void 0===this._responseList[this.active+1])&&(this.items[this.active+1].metadata.status="loading",this.set("items."+(this.active+1)+".metadata.status","loading"),this.notifyPath("items."+(this.active+1)+".metadata.status")),this.state="active item is "+(this.active+1),this.active=this.active+1)):(this.items[this.active].metadata.value=newp,this.set("items."+this.active+".metadata.value",newp),this.notifyPath("items."+this.active+".metadata.value"))}updateItems(op,item){var response=!1;"push"==op?(this.push("items",item),response=!0):"pop"==op?response=this.pop("items"):"splice"==op&&(this.splice("items",this.items.length,0,item),response=!0);const active=this.active;return this.set("active",0),this.set("active",active),this.notifyPath("active"),response}}window.customElements.define(LrnsysProgress.tag,LrnsysProgress);export{LrnsysProgress};