define(["exports"],function(_exports){function toArray(objectOrArray){return objectOrArray=objectOrArray||[],Array.isArray(objectOrArray)?objectOrArray:[objectOrArray]}function log(msg){return`[Vaadin.Router] ${msg}`}Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.Resolver=_exports.Router=void 0;const MODULE="module",NOMODULE="nomodule",bundleKeys=[MODULE,NOMODULE];function ensureBundle(src){if(!src.match(/.+\.[m]?js$/))throw new Error(log(`Unsupported type for bundle "${src}": .js or .mjs expected.`))}function ensureRoute(route){if(!route||!isString(route.path))throw new Error(log('Expected route config to be an object with a "path" string property, or an array of such objects'));const bundle=route.bundle,stringKeys=["component","redirect","bundle"];if(!(isFunction(route.action)||Array.isArray(route.children)||isFunction(route.children)||isObject(bundle)||stringKeys.some(key=>isString(route[key]))))throw new Error(log(`Expected route config "${route.path}" to include either "${stringKeys.join('", "')}" `+'or "action" function but none found.'));if(bundle)if(isString(bundle))ensureBundle(bundle);else{if(!bundleKeys.some(key=>key in bundle))throw new Error(log('Expected route bundle to include either "'+NOMODULE+'" or "'+MODULE+'" keys, or both'));bundleKeys.forEach(key=>key in bundle&&ensureBundle(bundle[key]))}route.redirect&&["bundle","component"].forEach(overriddenProp=>{overriddenProp in route&&console.warn(log(`Route config "${route.path}" has both "redirect" and "${overriddenProp}" properties, `+`and "redirect" will always override the latter. Did you mean to only use "${overriddenProp}"?`))})}function ensureRoutes(routes){toArray(routes).forEach(route=>ensureRoute(route))}function loadScript(src,key){let script=document.head.querySelector('script[src="'+src+'"][async]');return script||((script=document.createElement("script")).setAttribute("src",src),key===MODULE?script.setAttribute("type",MODULE):key===NOMODULE&&script.setAttribute(NOMODULE,""),script.async=!0),new Promise((resolve,reject)=>{script.onreadystatechange=script.onload=e=>{script.__dynamicImportLoaded=!0,resolve(e)},script.onerror=e=>{script.parentNode&&script.parentNode.removeChild(script),reject(e)},null===script.parentNode?document.head.appendChild(script):script.__dynamicImportLoaded&&resolve()})}function fireRouterEvent(type,detail){return!window.dispatchEvent(new CustomEvent(`vaadin-router-${type}`,{cancelable:"go"===type,detail:detail}))}function isObject(o){return"object"==typeof o&&!!o}function isFunction(f){return"function"==typeof f}function isString(s){return"string"==typeof s}function getNotFoundError(context){const error=new Error(log(`Page not found (${context.pathname})`));return error.context=context,error.code=404,error}const notFoundResult=new class NotFoundResult{};function vaadinRouterGlobalClickHandler(event){if(event.defaultPrevented)return;if(0!==event.button)return;if(event.shiftKey||event.ctrlKey||event.altKey||event.metaKey)return;let anchor=event.target;const path=event.composedPath?event.composedPath():event.path||[];for(let i=0;i<path.length;i++){const target=path[i];if(target.nodeName&&"a"===target.nodeName.toLowerCase()){anchor=target;break}}for(;anchor&&"a"!==anchor.nodeName.toLowerCase();)anchor=anchor.parentNode;anchor&&"a"===anchor.nodeName.toLowerCase()&&(anchor.target&&"_self"!==anchor.target.toLowerCase()||anchor.hasAttribute("download")||anchor.pathname===window.location.pathname&&""!==anchor.hash||(anchor.origin||function getAnchorOrigin(anchor){const port=anchor.port,protocol=anchor.protocol;return`${protocol}//${"http:"===protocol&&"80"===port||"https:"===protocol&&"443"===port?anchor.hostname:anchor.host}`}(anchor))===window.location.origin&&fireRouterEvent("go",{pathname:anchor.pathname})&&event.preventDefault())}const CLICK={activate(){window.document.addEventListener("click",vaadinRouterGlobalClickHandler)},inactivate(){window.document.removeEventListener("click",vaadinRouterGlobalClickHandler)}};function vaadinRouterGlobalPopstateHandler(event){"vaadin-router-ignore"!==event.state&&fireRouterEvent("go",{pathname:window.location.pathname})}/Trident/.test(navigator.userAgent)&&!isFunction(window.PopStateEvent)&&(window.PopStateEvent=function(inType,params){params=params||{};var e=document.createEvent("Event");return e.initEvent(inType,Boolean(params.bubbles),Boolean(params.cancelable)),e.state=params.state||null,e},window.PopStateEvent.prototype=window.Event.prototype);const POPSTATE={activate(){window.addEventListener("popstate",vaadinRouterGlobalPopstateHandler)},inactivate(){window.removeEventListener("popstate",vaadinRouterGlobalPopstateHandler)}};var pathToRegexp_1=pathToRegexp,parse_1=parse,compile_1=function compile(str,options){return tokensToFunction(parse(str,options))},tokensToFunction_1=tokensToFunction,tokensToRegExp_1=tokensToRegExp,DEFAULT_DELIMITER="/",DEFAULT_DELIMITERS="./",PATH_REGEXP=new RegExp(["(\\\\.)","(?:\\:(\\w+)(?:\\(((?:\\\\.|[^\\\\()])+)\\))?|\\(((?:\\\\.|[^\\\\()])+)\\))([+*?])?"].join("|"),"g");function parse(str,options){for(var res,tokens=[],key=0,index=0,path="",defaultDelimiter=options&&options.delimiter||DEFAULT_DELIMITER,delimiters=options&&options.delimiters||DEFAULT_DELIMITERS,pathEscaped=!1;null!==(res=PATH_REGEXP.exec(str));){var m=res[0],escaped=res[1],offset=res.index;if(path+=str.slice(index,offset),index=offset+m.length,escaped)path+=escaped[1],pathEscaped=!0;else{var prev="",next=str[index],name=res[2],capture=res[3],group=res[4],modifier=res[5];if(!pathEscaped&&path.length){var k=path.length-1;delimiters.indexOf(path[k])>-1&&(prev=path[k],path=path.slice(0,k))}path&&(tokens.push(path),path="",pathEscaped=!1);var partial=""!==prev&&void 0!==next&&next!==prev,repeat="+"===modifier||"*"===modifier,optional="?"===modifier||"*"===modifier,delimiter=prev||defaultDelimiter,pattern=capture||group;tokens.push({name:name||key++,prefix:prev,delimiter:delimiter,optional:optional,repeat:repeat,partial:partial,pattern:pattern?escapeGroup(pattern):"[^"+escapeString(delimiter)+"]+?"})}}return(path||index<str.length)&&tokens.push(path+str.substr(index)),tokens}function tokensToFunction(tokens){for(var matches=new Array(tokens.length),i=0;i<tokens.length;i++)"object"==typeof tokens[i]&&(matches[i]=new RegExp("^(?:"+tokens[i].pattern+")$"));return function(data,options){for(var path="",encode=options&&options.encode||encodeURIComponent,i=0;i<tokens.length;i++){var token=tokens[i];if("string"!=typeof token){var segment,value=data?data[token.name]:void 0;if(Array.isArray(value)){if(!token.repeat)throw new TypeError('Expected "'+token.name+'" to not repeat, but got array');if(0===value.length){if(token.optional)continue;throw new TypeError('Expected "'+token.name+'" to not be empty')}for(var j=0;j<value.length;j++){if(segment=encode(value[j],token),!matches[i].test(segment))throw new TypeError('Expected all "'+token.name+'" to match "'+token.pattern+'"');path+=(0===j?token.prefix:token.delimiter)+segment}}else if("string"!=typeof value&&"number"!=typeof value&&"boolean"!=typeof value){if(!token.optional)throw new TypeError('Expected "'+token.name+'" to be '+(token.repeat?"an array":"a string"));token.partial&&(path+=token.prefix)}else{if(segment=encode(String(value),token),!matches[i].test(segment))throw new TypeError('Expected "'+token.name+'" to match "'+token.pattern+'", but got "'+segment+'"');path+=token.prefix+segment}}else path+=token}return path}}function escapeString(str){return str.replace(/([.+*?=^!:${}()[\]|\/\\])/g,"\\$1")}function escapeGroup(group){return group.replace(/([=!:$\/()])/g,"\\$1")}function flags(options){return options&&options.sensitive?"":"i"}function tokensToRegExp(tokens,keys,options){for(var strict=(options=options||{}).strict,end=!1!==options.end,delimiter=escapeString(options.delimiter||DEFAULT_DELIMITER),delimiters=options.delimiters||DEFAULT_DELIMITERS,endsWith=[].concat(options.endsWith||[]).map(escapeString).concat("$").join("|"),route="",isEndDelimited=0===tokens.length,i=0;i<tokens.length;i++){var token=tokens[i];if("string"==typeof token)route+=escapeString(token),isEndDelimited=i===tokens.length-1&&delimiters.indexOf(token[token.length-1])>-1;else{var prefix=escapeString(token.prefix),capture=token.repeat?"(?:"+token.pattern+")(?:"+prefix+"(?:"+token.pattern+"))*":token.pattern;keys&&keys.push(token),token.optional?token.partial?route+=prefix+"("+capture+")?":route+="(?:"+prefix+"("+capture+"))?":route+=prefix+"("+capture+")"}}return end?(strict||(route+="(?:"+delimiter+")?"),route+="$"===endsWith?"$":"(?="+endsWith+")"):(strict||(route+="(?:"+delimiter+"(?="+endsWith+"))?"),isEndDelimited||(route+="(?="+delimiter+"|"+endsWith+")")),new RegExp("^"+route,flags(options))}function pathToRegexp(path,keys,options){return path instanceof RegExp?function regexpToRegexp(path,keys){if(!keys)return path;var groups=path.source.match(/\((?!\?)/g);if(groups)for(var i=0;i<groups.length;i++)keys.push({name:i,prefix:null,delimiter:null,optional:!1,repeat:!1,partial:!1,pattern:null});return path}(path,keys):Array.isArray(path)?function arrayToRegexp(path,keys,options){for(var parts=[],i=0;i<path.length;i++)parts.push(pathToRegexp(path[i],keys,options).source);return new RegExp("(?:"+parts.join("|")+")",flags(options))}(path,keys,options):function stringToRegexp(path,keys,options){return tokensToRegExp(parse(path,options),keys,options)}(path,keys,options)}pathToRegexp_1.parse=parse_1,pathToRegexp_1.compile=compile_1,pathToRegexp_1.tokensToFunction=tokensToFunction_1,pathToRegexp_1.tokensToRegExp=tokensToRegExp_1;const{hasOwnProperty:hasOwnProperty}=Object.prototype,cache=new Map;function decodeParam(val){try{return decodeURIComponent(val)}catch(err){return val}}function matchRoute(route,pathname,ignoreLeadingSlash,parentKeys,parentParams){let match,childMatches,childIndex=0,routepath=route.path||"";return"/"===routepath.charAt(0)&&(ignoreLeadingSlash&&(routepath=routepath.substr(1)),ignoreLeadingSlash=!0),{next(routeToSkip){if(route===routeToSkip)return{done:!0};const children=route.__children=route.__children||route.children;if(!match&&(match=function matchPath(routepath,path,exact,parentKeys,parentParams){const cacheKey=`${routepath}|${exact=!!exact}`;let regexp=cache.get(cacheKey);if(!regexp){const keys=[];regexp={keys:keys,pattern:pathToRegexp_1(routepath,keys,{end:exact,strict:""===routepath})},cache.set(cacheKey,regexp)}const m=regexp.pattern.exec(path);if(!m)return null;const params=Object.assign({},parentParams);for(let i=1;i<m.length;i++){const key=regexp.keys[i-1],prop=key.name,value=m[i];void 0===value&&hasOwnProperty.call(params,prop)||(key.repeat?params[prop]=value?value.split(key.delimiter).map(decodeParam):[]:params[prop]=value?decodeParam(value):value)}return{path:m[0],keys:(parentKeys||[]).concat(regexp.keys),params:params}}(routepath,pathname,!children,parentKeys,parentParams)))return{done:!1,value:{route:route,keys:match.keys,params:match.params,path:match.path}};if(match&&children)for(;childIndex<children.length;){if(!childMatches){const childRoute=children[childIndex];childRoute.parent=route;let matchedLength=match.path.length;matchedLength>0&&"/"===pathname.charAt(matchedLength)&&(matchedLength+=1),childMatches=matchRoute(childRoute,pathname.substr(matchedLength),ignoreLeadingSlash,match.keys,match.params)}const childMatch=childMatches.next(routeToSkip);if(!childMatch.done)return{done:!1,value:childMatch.value};childMatches=null,childIndex++}return{done:!0}}}}function resolveRoute(context){if(isFunction(context.route.action))return context.route.action(context)}cache.set("|false",{keys:[],pattern:/(?:)/});class Resolver{constructor(routes,options={}){if(Object(routes)!==routes)throw new TypeError("Invalid routes");this.baseUrl=options.baseUrl||"",this.errorHandler=options.errorHandler,this.resolveRoute=options.resolveRoute||resolveRoute,this.context=Object.assign({resolver:this},options.context),this.root=Array.isArray(routes)?{path:"",__children:routes,parent:null,__synthetic:!0}:routes,this.root.parent=null}getRoutes(){return[...this.root.__children]}setRoutes(routes){ensureRoutes(routes);const newRoutes=[...toArray(routes)];this.root.__children=newRoutes}addRoutes(routes){return ensureRoutes(routes),this.root.__children.push(...toArray(routes)),this.getRoutes()}removeRoutes(){this.setRoutes([])}resolve(pathnameOrContext){const context=Object.assign({},this.context,isString(pathnameOrContext)?{pathname:pathnameOrContext}:pathnameOrContext),match=matchRoute(this.root,this.__normalizePathname(context.pathname),this.baseUrl),resolve=this.resolveRoute;let matches=null,nextMatches=null,currentContext=context;function next(resume,parent=matches.value.route,prevResult){const routeToSkip=null===prevResult&&matches.value.route;return matches=nextMatches||match.next(routeToSkip),nextMatches=null,resume||!matches.done&&function isChildRoute(parentRoute,childRoute){let route=childRoute;for(;route;)if((route=route.parent)===parentRoute)return!0;return!1}(parent,matches.value.route)?matches.done?Promise.reject(getNotFoundError(context)):(function addRouteToChain(context,match){const{route:route,path:path}=match;if(route&&!route.__synthetic){const item={path:path,route:route};!function shouldDiscardOldChain(oldChain,route){return!route.parent||!oldChain||!oldChain.length||oldChain[oldChain.length-1].route!==route.parent}(context.chain,route)?context.chain.push(item):context.chain=[item]}}(context,matches.value),currentContext=Object.assign({},context,matches.value),Promise.resolve(resolve(currentContext)).then(resolution=>null!=resolution&&resolution!==notFoundResult?(currentContext.result=resolution.result||resolution,currentContext):next(resume,parent,resolution))):(nextMatches=matches,Promise.resolve(notFoundResult))}return context.next=next,Promise.resolve().then(()=>next(!0,this.root)).catch(error=>{const errorMessage=function generateErrorMessage(currentContext){let errorMessage=`Path '${currentContext.pathname}' is not properly resolved due to an error.`;const routePath=(currentContext.route||{}).path;return routePath&&(errorMessage+=` Resolution had failed on route: '${routePath}'`),errorMessage}(currentContext);if(error?console.warn(errorMessage):error=new Error(errorMessage),error.context=error.context||currentContext,error instanceof DOMException||(error.code=error.code||500),this.errorHandler)return currentContext.result=this.errorHandler(error),currentContext;throw error})}static __createUrl(url,base){return new URL(url,base)}get __effectiveBaseUrl(){return this.baseUrl?this.constructor.__createUrl(this.baseUrl,document.baseURI||document.URL).href.replace(/[^\/]*$/,""):""}__normalizePathname(pathname){if(!this.baseUrl)return pathname;const base=this.__effectiveBaseUrl,normalizedUrl=this.constructor.__createUrl(pathname,base).href;return normalizedUrl.slice(0,base.length)===base?normalizedUrl.slice(base.length):void 0}}_exports.Resolver=Resolver,Resolver.pathToRegexp=pathToRegexp_1;const{pathToRegexp:pathToRegexp$1}=Resolver,cache$1=new Map;function getRouteByName(routesByName,routeName){const routes=routesByName.get(routeName);if(routes&&routes.length>1)throw new Error(`Duplicate route with name "${routeName}".`+" Try seting unique 'name' route properties.");return routes&&routes[0]}function getRoutePath(route){let path=route.path;return void 0!==(path=Array.isArray(path)?path[0]:path)?path:""}function generateUrls(router,options={}){if(!(router instanceof Resolver))throw new TypeError("An instance of Resolver is expected");const routesByName=new Map;return(routeName,params)=>{let route=getRouteByName(routesByName,routeName);if(!(route||(routesByName.clear(),function cacheRoutes(routesByName,route,routes){const name=route.name||route.component;if(name&&(routesByName.has(name)?routesByName.get(name).push(route):routesByName.set(name,[route])),Array.isArray(routes))for(let i=0;i<routes.length;i++){const childRoute=routes[i];childRoute.parent=route,cacheRoutes(routesByName,childRoute,childRoute.__children||childRoute.children)}}(routesByName,router.root,router.root.__children),route=getRouteByName(routesByName,routeName))))throw new Error(`Route "${routeName}" not found`);let regexp=cache$1.get(route.fullPath);if(!regexp){let fullPath=getRoutePath(route),rt=route.parent;for(;rt;){const path=getRoutePath(rt);path&&(fullPath=path.replace(/\/$/,"")+"/"+fullPath.replace(/^\//,"")),rt=rt.parent}const tokens=pathToRegexp$1.parse(fullPath),toPath=pathToRegexp$1.tokensToFunction(tokens),keys=Object.create(null);for(let i=0;i<tokens.length;i++)isString(tokens[i])||(keys[tokens[i].name]=!0);regexp={toPath:toPath,keys:keys},cache$1.set(fullPath,regexp),route.fullPath=fullPath}let url=regexp.toPath(params,options)||"/";if(options.stringifyQueryParams&&params){const queryParams={},keys=Object.keys(params);for(let i=0;i<keys.length;i++){const key=keys[i];regexp.keys[key]||(queryParams[key]=params[key])}const query=options.stringifyQueryParams(queryParams);query&&(url+="?"===query.charAt(0)?query:`?${query}`)}return url}}let triggers=[];function setNavigationTriggers(newTriggers){triggers.forEach(trigger=>trigger.inactivate()),newTriggers.forEach(trigger=>trigger.activate()),triggers=newTriggers}const willAnimate=elem=>{const name=getComputedStyle(elem).getPropertyValue("animation-name");return name&&"none"!==name},waitForAnimation=(elem,cb)=>{const listener=()=>{elem.removeEventListener("animationend",listener),cb()};elem.addEventListener("animationend",listener)};function animate(elem,className){return elem.classList.add(className),new Promise(resolve=>{if(willAnimate(elem)){const rect=elem.getBoundingClientRect(),size=`height: ${rect.bottom-rect.top}px; width: ${rect.right-rect.left}px`;elem.setAttribute("style",`position: absolute; ${size}`),waitForAnimation(elem,()=>{elem.classList.remove(className),elem.removeAttribute("style"),resolve()})}else elem.classList.remove(className),resolve()})}const MAX_REDIRECT_COUNT=256;function isResultNotEmpty(result){return null!=result}function createLocation({pathname:pathname="",chain:chain=[],params:params={},redirectFrom:redirectFrom,resolver:resolver},route){const routes=chain.map(item=>item.route);return{baseUrl:resolver&&resolver.baseUrl||"",pathname:pathname,routes:routes,route:route||routes.length&&routes[routes.length-1]||null,params:params,redirectFrom:redirectFrom,getUrl:(userParams={})=>getPathnameForRouter(Router.pathToRegexp.compile(getMatchedPath(routes))(Object.assign({},params,userParams)),resolver)}}function createRedirect(context,pathname){const params=Object.assign({},context.params);return{redirect:{pathname:pathname,from:context.pathname,params:params}}}function runCallbackIfPossible(callback,args,thisArg){if(isFunction(callback))return callback.apply(thisArg,args)}function amend(amendmentFunction,args,element){return amendmentResult=>amendmentResult&&(amendmentResult.cancel||amendmentResult.redirect)?amendmentResult:element?runCallbackIfPossible(element[amendmentFunction],args,element):void 0}function removeDomNodes(nodes){if(nodes&&nodes.length){const parent=nodes[0].parentNode;for(let i=0;i<nodes.length;i++)parent.removeChild(nodes[i])}}function getPathnameForRouter(pathname,router){const base=router.__effectiveBaseUrl;return base?router.constructor.__createUrl(pathname.replace(/^\//,""),base).pathname:pathname}function getMatchedPath(chain){return chain.map(item=>item.path).reduce((a,b)=>b.length?a.replace(/\/$/,"")+"/"+b.replace(/^\//,""):a,"")}class Router extends Resolver{constructor(outlet,options){const baseElement=document.head.querySelector("base");super([],Object.assign({baseUrl:baseElement&&baseElement.getAttribute("href")},options)),this.resolveRoute=context=>this.__resolveRoute(context);const triggers=Router.NavigationTrigger;Router.setTriggers.apply(Router,Object.keys(triggers).map(key=>triggers[key])),this.baseUrl,this.ready,this.ready=Promise.resolve(outlet),this.location,this.location=createLocation({resolver:this}),this.__lastStartedRenderId=0,this.__navigationEventHandler=this.__onNavigationEvent.bind(this),this.setOutlet(outlet),this.subscribe()}__resolveRoute(context){const route=context.route;let callbacks=Promise.resolve();isFunction(route.children)&&(callbacks=callbacks.then(()=>route.children(function copyContextWithoutNext(context){const copy=Object.assign({},context);return delete copy.next,copy}(context))).then(children=>{isResultNotEmpty(children)||isFunction(route.children)||(children=route.children),function processNewChildren(newChildren,route){if(!Array.isArray(newChildren)&&!isObject(newChildren))throw new Error(log(`Incorrect "children" value for the route ${route.path}: expected array or object, but got ${newChildren}`));route.__children=[];const childRoutes=toArray(newChildren);for(let i=0;i<childRoutes.length;i++)ensureRoute(childRoutes[i]),route.__children.push(childRoutes[i])}(children,route)}));const commands={redirect:path=>createRedirect(context,path),component:component=>(function renderComponent(context,component){const element=document.createElement(component);element.location=createLocation(context);const index=context.chain.map(item=>item.route).indexOf(context.route);return context.chain[index].element=element,element})(context,component)};return callbacks.then(()=>runCallbackIfPossible(route.action,[context,commands],route)).then(result=>isResultNotEmpty(result)&&(result instanceof HTMLElement||result.redirect||result===notFoundResult)?result:isString(route.redirect)?commands.redirect(route.redirect):route.bundle?function loadBundle(bundle){return isString(bundle)?loadScript(bundle):Promise.race(bundleKeys.filter(key=>key in bundle).map(key=>loadScript(bundle[key],key)))}(route.bundle).then(()=>{},()=>{throw new Error(log(`Bundle not found: ${route.bundle}. Check if the file name is correct`))}):void 0).then(result=>isResultNotEmpty(result)?result:isString(route.component)?commands.component(route.component):void 0)}setOutlet(outlet){outlet&&this.__ensureOutlet(outlet),this.__outlet=outlet}getOutlet(){return this.__outlet}setRoutes(routes){this.__urlForName=void 0,super.setRoutes(routes),this.__onNavigationEvent()}render(pathnameOrContext,shouldUpdateHistory){const renderId=++this.__lastStartedRenderId,pathname=pathnameOrContext.pathname||pathnameOrContext;return this.ready=this.resolve(pathnameOrContext).then(context=>this.__fullyResolveChain(context)).then(context=>{if(renderId===this.__lastStartedRenderId){const previousContext=this.__previousContext;if(context===previousContext)return this.location;this.location=createLocation(context),fireRouterEvent("location-changed",{router:this,location:this.location}),shouldUpdateHistory&&this.__updateBrowserHistory(context.pathname,context.redirectFrom),this.__addAppearingContent(context,previousContext);const animationDone=this.__animateIfNeeded(context);return this.__runOnAfterEnterCallbacks(context),this.__runOnAfterLeaveCallbacks(context,previousContext),animationDone.then(()=>{if(renderId===this.__lastStartedRenderId)return this.__removeDisappearingContent(),this.__previousContext=context,this.location})}}).catch(error=>{if(renderId===this.__lastStartedRenderId)throw shouldUpdateHistory&&this.__updateBrowserHistory(pathname),removeDomNodes(this.__outlet&&this.__outlet.children),this.location=createLocation({pathname:pathname,resolver:this}),fireRouterEvent("error",{router:this,error:error,pathname:pathname}),error}),this.ready}__fullyResolveChain(originalContext,currentContext=originalContext){return this.__amendWithResolutionResult(currentContext).then(amendedContext=>{const initialContext=amendedContext!==currentContext?amendedContext:originalContext;return amendedContext.next().then(nextContext=>{if(null===nextContext||nextContext===notFoundResult){if(getPathnameForRouter(getMatchedPath(amendedContext.chain),amendedContext.resolver)!==amendedContext.pathname)throw getNotFoundError(initialContext)}return nextContext&&nextContext!==notFoundResult?this.__fullyResolveChain(initialContext,nextContext):this.__amendWithOnBeforeCallbacks(initialContext)})})}__amendWithResolutionResult(context){const result=context.result;return result instanceof HTMLElement?Promise.resolve(context):result.redirect?this.__redirect(result.redirect,context.__redirectCount).then(context=>this.__amendWithResolutionResult(context)):result instanceof Error?Promise.reject(result):Promise.reject(new Error(log(`Invalid route resolution result for path "${context.pathname}". `+`Expected redirect object or HTML element, but got: "${function logValue(value){if("object"!=typeof value)return String(value);const stringType=Object.prototype.toString.call(value).match(/ (.*)\]$/)[1];return"Object"===stringType||"Array"===stringType?`${stringType} ${JSON.stringify(value)}`:stringType}(result)}". `+"Double check the action return value for the route.")))}__amendWithOnBeforeCallbacks(contextWithFullChain){return this.__runOnBeforeCallbacks(contextWithFullChain).then(amendedContext=>amendedContext===this.__previousContext||amendedContext===contextWithFullChain?amendedContext:this.__fullyResolveChain(amendedContext))}__runOnBeforeCallbacks(newContext){const previousChain=(this.__previousContext||{}).chain||[],newChain=newContext.chain;let callbacks=Promise.resolve();const prevent=()=>({cancel:!0}),redirect=pathname=>createRedirect(newContext,pathname);if(newContext.__divergedChainIndex=0,previousChain.length){for(let i=0;i<Math.min(previousChain.length,newChain.length)&&(previousChain[i].route===newChain[i].route&&previousChain[i].path===newChain[i].path&&(previousChain[i].element&&previousChain[i].element.localName)===(newChain[i].element&&newChain[i].element.localName));i=++newContext.__divergedChainIndex);for(let i=previousChain.length-1;i>=newContext.__divergedChainIndex;i--){const location=createLocation(newContext);callbacks=callbacks.then(amend("onBeforeLeave",[location,{prevent:prevent},this],previousChain[i].element)).then(result=>{if(!(result||{}).redirect)return result})}}for(let i=newContext.__divergedChainIndex;i<newChain.length;i++){const location=createLocation(newContext,newChain[i].route);callbacks=callbacks.then(amend("onBeforeEnter",[location,{prevent:prevent,redirect:redirect},this],newChain[i].element))}return callbacks.then(amendmentResult=>{if(amendmentResult){if(amendmentResult.cancel)return this.__previousContext;if(amendmentResult.redirect)return this.__redirect(amendmentResult.redirect,newContext.__redirectCount)}return newContext})}__redirect(redirectData,counter){if(counter>MAX_REDIRECT_COUNT)throw new Error(log(`Too many redirects when rendering ${redirectData.from}`));return this.resolve({pathname:this.urlForPath(redirectData.pathname,redirectData.params),redirectFrom:redirectData.from,__redirectCount:(counter||0)+1})}__ensureOutlet(outlet=this.__outlet){if(!(outlet instanceof Node))throw new TypeError(log(`Expected router outlet to be a valid DOM Node (but got ${outlet})`))}__updateBrowserHistory(pathname,replace){if(window.location.pathname!==pathname){const changeState=replace?"replaceState":"pushState";window.history[changeState](null,document.title,pathname),window.dispatchEvent(new PopStateEvent("popstate",{state:"vaadin-router-ignore"}))}}__addAppearingContent(context,previousContext){this.__ensureOutlet(),this.__removeAppearingContent();let deepestCommonParent=this.__outlet;for(let i=0;i<context.__divergedChainIndex;i++){const unchangedElement=previousContext&&previousContext.chain[i].element;if(unchangedElement){if(unchangedElement.parentNode!==deepestCommonParent)break;context.chain[i].element=unchangedElement,deepestCommonParent=unchangedElement}}this.__disappearingContent=Array.from(deepestCommonParent.children),this.__appearingContent=[];let parentElement=deepestCommonParent;for(let i=context.__divergedChainIndex;i<context.chain.length;i++){const elementToAdd=context.chain[i].element;elementToAdd&&(parentElement.appendChild(elementToAdd),parentElement===deepestCommonParent&&this.__appearingContent.push(elementToAdd),parentElement=elementToAdd)}}__removeDisappearingContent(){this.__disappearingContent&&removeDomNodes(this.__disappearingContent),this.__disappearingContent=null,this.__appearingContent=null}__removeAppearingContent(){this.__disappearingContent&&this.__appearingContent&&(removeDomNodes(this.__appearingContent),this.__disappearingContent=null,this.__appearingContent=null)}__runOnAfterLeaveCallbacks(currentContext,targetContext){if(targetContext)for(let i=targetContext.chain.length-1;i>=currentContext.__divergedChainIndex;i--){const currentComponent=targetContext.chain[i].element;if(currentComponent)try{const location=createLocation(currentContext);runCallbackIfPossible(currentComponent.onAfterLeave,[location,{},targetContext.resolver],currentComponent)}finally{removeDomNodes(currentComponent.children)}}}__runOnAfterEnterCallbacks(currentContext){for(let i=currentContext.__divergedChainIndex;i<currentContext.chain.length;i++){const currentComponent=currentContext.chain[i].element||{},location=createLocation(currentContext,currentContext.chain[i].route);runCallbackIfPossible(currentComponent.onAfterEnter,[location,{},currentContext.resolver],currentComponent)}}__animateIfNeeded(context){const from=(this.__disappearingContent||[])[0],to=(this.__appearingContent||[])[0],promises=[],chain=context.chain;let config;for(let i=chain.length;i>0;i--)if(chain[i-1].route.animate){config=chain[i-1].route.animate;break}if(from&&to&&config){const leave=isObject(config)&&config.leave||"leaving",enter=isObject(config)&&config.enter||"entering";promises.push(animate(from,leave)),promises.push(animate(to,enter))}return Promise.all(promises).then(()=>context)}subscribe(){window.addEventListener("vaadin-router-go",this.__navigationEventHandler)}unsubscribe(){window.removeEventListener("vaadin-router-go",this.__navigationEventHandler)}__onNavigationEvent(event){const pathname=event?event.detail.pathname:window.location.pathname;isString(this.__normalizePathname(pathname))&&(event&&event.preventDefault&&event.preventDefault(),this.render(pathname,!0))}static setTriggers(...triggers){setNavigationTriggers(triggers)}urlForName(name,params){return this.__urlForName||(this.__urlForName=generateUrls(this)),getPathnameForRouter(this.__urlForName(name,params),this)}urlForPath(path,params){return getPathnameForRouter(Router.pathToRegexp.compile(path)(params),this)}static go(pathname){return fireRouterEvent("go",{pathname:pathname})}}_exports.Router=Router;const DEV_MODE_CODE_REGEXP=/\/\*\*\s+vaadin-dev-mode:start([\s\S]*)vaadin-dev-mode:end\s+\*\*\//i;function uncommentAndRun(callback,args){if("function"!=typeof callback)return;const match=DEV_MODE_CODE_REGEXP.exec(callback.toString());if(match)try{callback=new Function(match[1])}catch(e){console.log("vaadin-development-mode-detector: uncommentAndRun() failed",e)}return callback(args)}window.Vaadin=window.Vaadin||{};const runIfDevelopmentMode=function(callback,args){if(window.Vaadin.developmentMode)return uncommentAndRun(callback,args)};function maybeGatherAndSendStats(){}void 0===window.Vaadin.developmentMode&&(window.Vaadin.developmentMode=function isDevelopmentMode(){try{return function isForcedDevelopmentMode(){return localStorage.getItem("vaadin.developmentmode.force")}()||function isLocalhost(){return["localhost","127.0.0.1"].indexOf(window.location.hostname)>=0}()&&!function isMinified(){return uncommentAndRun(function test(){return!0})}()&&!function isFlowProductionMode(){if(window.Vaadin&&window.Vaadin.Flow&&window.Vaadin.Flow.clients){const productionModeApps=Object.keys(window.Vaadin.Flow.clients).map(key=>window.Vaadin.Flow.clients[key]).filter(client=>client.productionMode);if(productionModeApps.length>0)return!0}return!1}()}catch(e){return!1}}());window.Vaadin=window.Vaadin||{},window.Vaadin.registrations=window.Vaadin.registrations||[],window.Vaadin.registrations.push({is:"@vaadin/router",version:"1.2.0"}),runIfDevelopmentMode(maybeGatherAndSendStats),Router.NavigationTrigger={POPSTATE:POPSTATE,CLICK:CLICK}});