import{PolymerElement}from"../../polymer-element.js";import{TemplateInstanceBase,templatize,modelForElement}from"../utils/templatize.js";import{Debouncer}from"../utils/debounce.js";import{enqueueDebouncer,flush}from"../utils/flush.js";import{OptionalMutableData}from"../mixins/mutable-data.js";import{matches,translate}from"../utils/path.js";import{timeOut,microTask}from"../utils/async.js";import{wrap}from"../utils/wrap.js";const domRepeatBase=OptionalMutableData(PolymerElement);export class DomRepeat extends domRepeatBase{static get is(){return"dom-repeat"}static get template(){return null}static get properties(){return{items:{type:Array},as:{type:String,value:"item"},indexAs:{type:String,value:"index"},itemsIndexAs:{type:String,value:"itemsIndex"},sort:{type:Function,observer:"__sortChanged"},filter:{type:Function,observer:"__filterChanged"},observe:{type:String,observer:"__observeChanged"},delay:Number,renderedItemCount:{type:Number,notify:!0,readOnly:!0},initialCount:{type:Number,observer:"__initializeChunking"},targetFramerate:{type:Number,value:20},_targetFrameTime:{type:Number,computed:"__computeFrameTime(targetFramerate)"}}}static get observers(){return["__itemsChanged(items.*)"]}constructor(){super(),this.__instances=[],this.__limit=1/0,this.__pool=[],this.__renderDebouncer=null,this.__itemsIdxToInstIdx={},this.__chunkCount=null,this.__lastChunkTime=null,this.__sortFn=null,this.__filterFn=null,this.__observePaths=null,this.__ctor=null,this.__isDetached=!0,this.template=null}disconnectedCallback(){super.disconnectedCallback(),this.__isDetached=!0;for(let i=0;i<this.__instances.length;i++)this.__detachInstance(i)}connectedCallback(){if(super.connectedCallback(),this.style.display="none",this.__isDetached){this.__isDetached=!1;let wrappedParent=wrap(wrap(this).parentNode);for(let i=0;i<this.__instances.length;i++)this.__attachInstance(i,wrappedParent)}}__ensureTemplatized(){if(!this.__ctor){let template=this.template=this.querySelector("template");if(!template){let observer=new MutationObserver(()=>{if(!this.querySelector("template"))throw new Error("dom-repeat requires a <template> child");observer.disconnect(),this.__render()});return observer.observe(this,{childList:!0}),!1}let instanceProps={};instanceProps[this.as]=!0,instanceProps[this.indexAs]=!0,instanceProps[this.itemsIndexAs]=!0,this.__ctor=templatize(template,this,{mutableData:this.mutableData,parentModel:!0,instanceProps:instanceProps,forwardHostProp:function(prop,value){let i$=this.__instances;for(let inst,i=0;i<i$.length&&(inst=i$[i]);i++)inst.forwardHostProp(prop,value)},notifyInstanceProp:function(inst,prop,value){if(matches(this.as,prop)){let idx=inst[this.itemsIndexAs];prop==this.as&&(this.items[idx]=value);let path=translate(this.as,`${JSCompiler_renameProperty("items",this)}.${idx}`,prop);this.notifyPath(path,value)}}})}return!0}__getMethodHost(){return this.__dataHost._methodHost||this.__dataHost}__functionFromPropertyValue(functionOrMethodName){if("string"==typeof functionOrMethodName){let methodName=functionOrMethodName,obj=this.__getMethodHost();return function(){return obj[methodName].apply(obj,arguments)}}return functionOrMethodName}__sortChanged(sort){this.__sortFn=this.__functionFromPropertyValue(sort),this.items&&this.__debounceRender(this.__render)}__filterChanged(filter){this.__filterFn=this.__functionFromPropertyValue(filter),this.items&&this.__debounceRender(this.__render)}__computeFrameTime(rate){return Math.ceil(1e3/rate)}__initializeChunking(){this.initialCount&&(this.__limit=this.initialCount,this.__chunkCount=this.initialCount,this.__lastChunkTime=performance.now())}__tryRenderChunk(){this.items&&this.__limit<this.items.length&&this.__debounceRender(this.__requestRenderChunk)}__requestRenderChunk(){requestAnimationFrame(()=>this.__renderChunk())}__renderChunk(){let currChunkTime=performance.now(),ratio=this._targetFrameTime/(currChunkTime-this.__lastChunkTime);this.__chunkCount=Math.round(this.__chunkCount*ratio)||1,this.__limit+=this.__chunkCount,this.__lastChunkTime=currChunkTime,this.__debounceRender(this.__render)}__observeChanged(){this.__observePaths=this.observe&&this.observe.replace(".*",".").split(" ")}__itemsChanged(change){this.items&&!Array.isArray(this.items)&&console.warn("dom-repeat expected array for `items`, found",this.items),this.__handleItemPath(change.path,change.value)||(this.__initializeChunking(),this.__debounceRender(this.__render))}__handleObservedPaths(path){if(this.__sortFn||this.__filterFn)if(path){if(this.__observePaths){let paths=this.__observePaths;for(let i=0;i<paths.length;i++)0===path.indexOf(paths[i])&&this.__debounceRender(this.__render,this.delay)}}else this.__debounceRender(this.__render,this.delay)}__debounceRender(fn,delay=0){this.__renderDebouncer=Debouncer.debounce(this.__renderDebouncer,delay>0?timeOut.after(delay):microTask,fn.bind(this)),enqueueDebouncer(this.__renderDebouncer)}render(){this.__debounceRender(this.__render),flush()}__render(){this.__ensureTemplatized()&&(this.__applyFullRefresh(),this.__pool.length=0,this._setRenderedItemCount(this.__instances.length),this.dispatchEvent(new CustomEvent("dom-change",{bubbles:!0,composed:!0})),this.__tryRenderChunk())}__applyFullRefresh(){let items=this.items||[],isntIdxToItemsIdx=new Array(items.length);for(let i=0;i<items.length;i++)isntIdxToItemsIdx[i]=i;this.__filterFn&&(isntIdxToItemsIdx=isntIdxToItemsIdx.filter((i,idx,array)=>this.__filterFn(items[i],idx,array))),this.__sortFn&&isntIdxToItemsIdx.sort((a,b)=>this.__sortFn(items[a],items[b]));const itemsIdxToInstIdx=this.__itemsIdxToInstIdx={};let instIdx=0;const limit=Math.min(isntIdxToItemsIdx.length,this.__limit);for(;instIdx<limit;instIdx++){let inst=this.__instances[instIdx],itemIdx=isntIdxToItemsIdx[instIdx],item=items[itemIdx];itemsIdxToInstIdx[itemIdx]=instIdx,inst?(inst._setPendingProperty(this.as,item),inst._setPendingProperty(this.indexAs,instIdx),inst._setPendingProperty(this.itemsIndexAs,itemIdx),inst._flushProperties()):this.__insertInstance(item,instIdx,itemIdx)}for(let i=this.__instances.length-1;i>=instIdx;i--)this.__detachAndRemoveInstance(i)}__detachInstance(idx){let inst=this.__instances[idx];const wrappedRoot=wrap(inst.root);for(let i=0;i<inst.children.length;i++){let el=inst.children[i];wrappedRoot.appendChild(el)}return inst}__attachInstance(idx,parent){let inst=this.__instances[idx];parent.insertBefore(inst.root,this)}__detachAndRemoveInstance(idx){let inst=this.__detachInstance(idx);inst&&this.__pool.push(inst),this.__instances.splice(idx,1)}__stampInstance(item,instIdx,itemIdx){let model={};return model[this.as]=item,model[this.indexAs]=instIdx,model[this.itemsIndexAs]=itemIdx,new this.__ctor(model)}__insertInstance(item,instIdx,itemIdx){let inst=this.__pool.pop();inst?(inst._setPendingProperty(this.as,item),inst._setPendingProperty(this.indexAs,instIdx),inst._setPendingProperty(this.itemsIndexAs,itemIdx),inst._flushProperties()):inst=this.__stampInstance(item,instIdx,itemIdx);let beforeRow=this.__instances[instIdx+1],beforeNode=beforeRow?beforeRow.children[0]:this;return wrap(wrap(this).parentNode).insertBefore(inst.root,beforeNode),this.__instances[instIdx]=inst,inst}_showHideChildren(hidden){for(let i=0;i<this.__instances.length;i++)this.__instances[i]._showHideChildren(hidden)}__handleItemPath(path,value){let itemsPath=path.slice(6),dot=itemsPath.indexOf("."),itemsIdx=dot<0?itemsPath:itemsPath.substring(0,dot);if(itemsIdx==parseInt(itemsIdx,10)){let itemSubPath=dot<0?"":itemsPath.substring(dot+1);this.__handleObservedPaths(itemSubPath);let instIdx=this.__itemsIdxToInstIdx[itemsIdx],inst=this.__instances[instIdx];if(inst){let itemPath=this.as+(itemSubPath?"."+itemSubPath:"");inst._setPendingPropertyOrPath(itemPath,value,!1,!0),inst._flushProperties()}return!0}}itemForElement(el){let instance=this.modelForElement(el);return instance&&instance[this.as]}indexForElement(el){let instance=this.modelForElement(el);return instance&&instance[this.indexAs]}modelForElement(el){return modelForElement(this.template,el)}}customElements.define(DomRepeat.is,DomRepeat);