import Resolver from"./resolver/resolver.js";import generateUrls from"./resolver/generateUrls.js";import setNavigationTriggers from"./triggers/setNavigationTriggers.js";import animate from"./transitions/animate.js";import{ensureRoute,fireRouterEvent,loadBundle,log,logValue,toArray,isFunction,isString,isObject,getNotFoundError,notFoundResult}from"./utils.js";const MAX_REDIRECT_COUNT=256;function isResultNotEmpty(result){return null!=result}function createLocation({pathname:pathname="",chain:chain=[],params:params={},redirectFrom:redirectFrom,resolver:resolver},route){const routes=chain.map(item=>item.route);return{baseUrl:resolver&&resolver.baseUrl||"",pathname:pathname,routes:routes,route:route||routes.length&&routes[routes.length-1]||null,params:params,redirectFrom:redirectFrom,getUrl:(userParams={})=>getPathnameForRouter(Router.pathToRegexp.compile(getMatchedPath(routes))(Object.assign({},params,userParams)),resolver)}}function createRedirect(context,pathname){const params=Object.assign({},context.params);return{redirect:{pathname:pathname,from:context.pathname,params:params}}}function runCallbackIfPossible(callback,args,thisArg){if(isFunction(callback))return callback.apply(thisArg,args)}function amend(amendmentFunction,args,element){return amendmentResult=>amendmentResult&&(amendmentResult.cancel||amendmentResult.redirect)?amendmentResult:element?runCallbackIfPossible(element[amendmentFunction],args,element):void 0}function removeDomNodes(nodes){if(nodes&&nodes.length){const parent=nodes[0].parentNode;for(let i=0;i<nodes.length;i++)parent.removeChild(nodes[i])}}function getPathnameForRouter(pathname,router){const base=router.__effectiveBaseUrl;return base?router.constructor.__createUrl(pathname.replace(/^\//,""),base).pathname:pathname}function getMatchedPath(chain){return chain.map(item=>item.path).reduce((a,b)=>b.length?a.replace(/\/$/,"")+"/"+b.replace(/^\//,""):a,"")}export class Router extends Resolver{constructor(outlet,options){const baseElement=document.head.querySelector("base");super([],Object.assign({baseUrl:baseElement&&baseElement.getAttribute("href")},options)),this.resolveRoute=context=>this.__resolveRoute(context);const triggers=Router.NavigationTrigger;Router.setTriggers.apply(Router,Object.keys(triggers).map(key=>triggers[key])),this.baseUrl,this.ready,this.ready=Promise.resolve(outlet),this.location,this.location=createLocation({resolver:this}),this.__lastStartedRenderId=0,this.__navigationEventHandler=this.__onNavigationEvent.bind(this),this.setOutlet(outlet),this.subscribe()}__resolveRoute(context){const route=context.route;let callbacks=Promise.resolve();isFunction(route.children)&&(callbacks=callbacks.then(()=>route.children(function copyContextWithoutNext(context){const copy=Object.assign({},context);return delete copy.next,copy}(context))).then(children=>{isResultNotEmpty(children)||isFunction(route.children)||(children=route.children),function processNewChildren(newChildren,route){if(!Array.isArray(newChildren)&&!isObject(newChildren))throw new Error(log(`Incorrect "children" value for the route ${route.path}: expected array or object, but got ${newChildren}`));route.__children=[];const childRoutes=toArray(newChildren);for(let i=0;i<childRoutes.length;i++)ensureRoute(childRoutes[i]),route.__children.push(childRoutes[i])}(children,route)}));const commands={redirect:path=>createRedirect(context,path),component:component=>(function renderComponent(context,component){const element=document.createElement(component);element.location=createLocation(context);const index=context.chain.map(item=>item.route).indexOf(context.route);return context.chain[index].element=element,element})(context,component)};return callbacks.then(()=>runCallbackIfPossible(route.action,[context,commands],route)).then(result=>isResultNotEmpty(result)&&(result instanceof HTMLElement||result.redirect||result===notFoundResult)?result:isString(route.redirect)?commands.redirect(route.redirect):route.bundle?loadBundle(route.bundle).then(()=>{},()=>{throw new Error(log(`Bundle not found: ${route.bundle}. Check if the file name is correct`))}):void 0).then(result=>isResultNotEmpty(result)?result:isString(route.component)?commands.component(route.component):void 0)}setOutlet(outlet){outlet&&this.__ensureOutlet(outlet),this.__outlet=outlet}getOutlet(){return this.__outlet}setRoutes(routes){this.__urlForName=void 0,super.setRoutes(routes),this.__onNavigationEvent()}render(pathnameOrContext,shouldUpdateHistory){const renderId=++this.__lastStartedRenderId,pathname=pathnameOrContext.pathname||pathnameOrContext;return this.ready=this.resolve(pathnameOrContext).then(context=>this.__fullyResolveChain(context)).then(context=>{if(renderId===this.__lastStartedRenderId){const previousContext=this.__previousContext;if(context===previousContext)return this.location;this.location=createLocation(context),fireRouterEvent("location-changed",{router:this,location:this.location}),shouldUpdateHistory&&this.__updateBrowserHistory(context.pathname,context.redirectFrom),this.__addAppearingContent(context,previousContext);const animationDone=this.__animateIfNeeded(context);return this.__runOnAfterEnterCallbacks(context),this.__runOnAfterLeaveCallbacks(context,previousContext),animationDone.then(()=>{if(renderId===this.__lastStartedRenderId)return this.__removeDisappearingContent(),this.__previousContext=context,this.location})}}).catch(error=>{if(renderId===this.__lastStartedRenderId)throw shouldUpdateHistory&&this.__updateBrowserHistory(pathname),removeDomNodes(this.__outlet&&this.__outlet.children),this.location=createLocation({pathname:pathname,resolver:this}),fireRouterEvent("error",{router:this,error:error,pathname:pathname}),error}),this.ready}__fullyResolveChain(originalContext,currentContext=originalContext){return this.__amendWithResolutionResult(currentContext).then(amendedContext=>{const initialContext=amendedContext!==currentContext?amendedContext:originalContext;return amendedContext.next().then(nextContext=>{if(null===nextContext||nextContext===notFoundResult){if(getPathnameForRouter(getMatchedPath(amendedContext.chain),amendedContext.resolver)!==amendedContext.pathname)throw getNotFoundError(initialContext)}return nextContext&&nextContext!==notFoundResult?this.__fullyResolveChain(initialContext,nextContext):this.__amendWithOnBeforeCallbacks(initialContext)})})}__amendWithResolutionResult(context){const result=context.result;return result instanceof HTMLElement?Promise.resolve(context):result.redirect?this.__redirect(result.redirect,context.__redirectCount).then(context=>this.__amendWithResolutionResult(context)):result instanceof Error?Promise.reject(result):Promise.reject(new Error(log(`Invalid route resolution result for path "${context.pathname}". `+`Expected redirect object or HTML element, but got: "${logValue(result)}". `+"Double check the action return value for the route.")))}__amendWithOnBeforeCallbacks(contextWithFullChain){return this.__runOnBeforeCallbacks(contextWithFullChain).then(amendedContext=>amendedContext===this.__previousContext||amendedContext===contextWithFullChain?amendedContext:this.__fullyResolveChain(amendedContext))}__runOnBeforeCallbacks(newContext){const previousChain=(this.__previousContext||{}).chain||[],newChain=newContext.chain;let callbacks=Promise.resolve();const prevent=()=>({cancel:!0}),redirect=pathname=>createRedirect(newContext,pathname);if(newContext.__divergedChainIndex=0,previousChain.length){for(let i=0;i<Math.min(previousChain.length,newChain.length)&&(previousChain[i].route===newChain[i].route&&previousChain[i].path===newChain[i].path&&(previousChain[i].element&&previousChain[i].element.localName)===(newChain[i].element&&newChain[i].element.localName));i=++newContext.__divergedChainIndex);for(let i=previousChain.length-1;i>=newContext.__divergedChainIndex;i--){const location=createLocation(newContext);callbacks=callbacks.then(amend("onBeforeLeave",[location,{prevent:prevent},this],previousChain[i].element)).then(result=>{if(!(result||{}).redirect)return result})}}for(let i=newContext.__divergedChainIndex;i<newChain.length;i++){const location=createLocation(newContext,newChain[i].route);callbacks=callbacks.then(amend("onBeforeEnter",[location,{prevent:prevent,redirect:redirect},this],newChain[i].element))}return callbacks.then(amendmentResult=>{if(amendmentResult){if(amendmentResult.cancel)return this.__previousContext;if(amendmentResult.redirect)return this.__redirect(amendmentResult.redirect,newContext.__redirectCount)}return newContext})}__redirect(redirectData,counter){if(counter>MAX_REDIRECT_COUNT)throw new Error(log(`Too many redirects when rendering ${redirectData.from}`));return this.resolve({pathname:this.urlForPath(redirectData.pathname,redirectData.params),redirectFrom:redirectData.from,__redirectCount:(counter||0)+1})}__ensureOutlet(outlet=this.__outlet){if(!(outlet instanceof Node))throw new TypeError(log(`Expected router outlet to be a valid DOM Node (but got ${outlet})`))}__updateBrowserHistory(pathname,replace){if(window.location.pathname!==pathname){const changeState=replace?"replaceState":"pushState";window.history[changeState](null,document.title,pathname),window.dispatchEvent(new PopStateEvent("popstate",{state:"vaadin-router-ignore"}))}}__addAppearingContent(context,previousContext){this.__ensureOutlet(),this.__removeAppearingContent();let deepestCommonParent=this.__outlet;for(let i=0;i<context.__divergedChainIndex;i++){const unchangedElement=previousContext&&previousContext.chain[i].element;if(unchangedElement){if(unchangedElement.parentNode!==deepestCommonParent)break;context.chain[i].element=unchangedElement,deepestCommonParent=unchangedElement}}this.__disappearingContent=Array.from(deepestCommonParent.children),this.__appearingContent=[];let parentElement=deepestCommonParent;for(let i=context.__divergedChainIndex;i<context.chain.length;i++){const elementToAdd=context.chain[i].element;elementToAdd&&(parentElement.appendChild(elementToAdd),parentElement===deepestCommonParent&&this.__appearingContent.push(elementToAdd),parentElement=elementToAdd)}}__removeDisappearingContent(){this.__disappearingContent&&removeDomNodes(this.__disappearingContent),this.__disappearingContent=null,this.__appearingContent=null}__removeAppearingContent(){this.__disappearingContent&&this.__appearingContent&&(removeDomNodes(this.__appearingContent),this.__disappearingContent=null,this.__appearingContent=null)}__runOnAfterLeaveCallbacks(currentContext,targetContext){if(targetContext)for(let i=targetContext.chain.length-1;i>=currentContext.__divergedChainIndex;i--){const currentComponent=targetContext.chain[i].element;if(currentComponent)try{const location=createLocation(currentContext);runCallbackIfPossible(currentComponent.onAfterLeave,[location,{},targetContext.resolver],currentComponent)}finally{removeDomNodes(currentComponent.children)}}}__runOnAfterEnterCallbacks(currentContext){for(let i=currentContext.__divergedChainIndex;i<currentContext.chain.length;i++){const currentComponent=currentContext.chain[i].element||{},location=createLocation(currentContext,currentContext.chain[i].route);runCallbackIfPossible(currentComponent.onAfterEnter,[location,{},currentContext.resolver],currentComponent)}}__animateIfNeeded(context){const from=(this.__disappearingContent||[])[0],to=(this.__appearingContent||[])[0],promises=[],chain=context.chain;let config;for(let i=chain.length;i>0;i--)if(chain[i-1].route.animate){config=chain[i-1].route.animate;break}if(from&&to&&config){const leave=isObject(config)&&config.leave||"leaving",enter=isObject(config)&&config.enter||"entering";promises.push(animate(from,leave)),promises.push(animate(to,enter))}return Promise.all(promises).then(()=>context)}subscribe(){window.addEventListener("vaadin-router-go",this.__navigationEventHandler)}unsubscribe(){window.removeEventListener("vaadin-router-go",this.__navigationEventHandler)}__onNavigationEvent(event){const pathname=event?event.detail.pathname:window.location.pathname;isString(this.__normalizePathname(pathname))&&(event&&event.preventDefault&&event.preventDefault(),this.render(pathname,!0))}static setTriggers(...triggers){setNavigationTriggers(triggers)}urlForName(name,params){return this.__urlForName||(this.__urlForName=generateUrls(this)),getPathnameForRouter(this.__urlForName(name,params),this)}urlForPath(path,params){return getPathnameForRouter(Router.pathToRegexp.compile(path)(params),this)}static go(pathname){return fireRouterEvent("go",{pathname:pathname})}}