import{extend,hop}from"./utils.js";import{defineProperty,objCreate}from"./es5.js";import Compiler from"./compiler.js";import parser from"../../intl-messageformat-parser/src/parser.js";export default MessageFormat;function MessageFormat(message,locales,formats){var ast="string"==typeof message?MessageFormat.__parse(message):message;if(!ast||"messageFormatPattern"!==ast.type)throw new TypeError("A message must be provided as a String or AST.");formats=this._mergeFormats(MessageFormat.formats,formats),defineProperty(this,"_locale",{value:this._resolveLocale(locales)});var pluralFn=this._findPluralRuleFunction(this._locale),pattern=this._compilePattern(ast,locales,formats,pluralFn),messageFormat=this;this.format=function(values){try{return messageFormat._format(pattern,values)}catch(e){throw e.variableId?new Error("The intl string context variable '"+e.variableId+"' was not provided to the string '"+message+"'"):e}}}defineProperty(MessageFormat,"formats",{enumerable:!0,value:{number:{currency:{style:"currency"},percent:{style:"percent"}},date:{short:{month:"numeric",day:"numeric",year:"2-digit"},medium:{month:"short",day:"numeric",year:"numeric"},long:{month:"long",day:"numeric",year:"numeric"},full:{weekday:"long",month:"long",day:"numeric",year:"numeric"}},time:{short:{hour:"numeric",minute:"numeric"},medium:{hour:"numeric",minute:"numeric",second:"numeric"},long:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"},full:{hour:"numeric",minute:"numeric",second:"numeric",timeZoneName:"short"}}}}),defineProperty(MessageFormat,"__localeData__",{value:objCreate(null)}),defineProperty(MessageFormat,"__addLocaleData",{value:function(data){if(!data||!data.locale)throw new Error("Locale data provided to IntlMessageFormat is missing a `locale` property");MessageFormat.__localeData__[data.locale.toLowerCase()]=data}}),defineProperty(MessageFormat,"__parse",{value:parser.parse}),defineProperty(MessageFormat,"defaultLocale",{enumerable:!0,writable:!0,value:void 0}),MessageFormat.prototype.resolvedOptions=function(){return{locale:this._locale}},MessageFormat.prototype._compilePattern=function(ast,locales,formats,pluralFn){return new Compiler(locales,formats,pluralFn).compile(ast)},MessageFormat.prototype._findPluralRuleFunction=function(locale){for(var localeData=MessageFormat.__localeData__,data=localeData[locale.toLowerCase()];data;){if(data.pluralRuleFunction)return data.pluralRuleFunction;data=data.parentLocale&&localeData[data.parentLocale.toLowerCase()]}throw new Error("Locale data added to IntlMessageFormat is missing a `pluralRuleFunction` for :"+locale)},MessageFormat.prototype._format=function(pattern,values){var i,len,part,id,value,err,result="";for(i=0,len=pattern.length;i<len;i+=1)if("string"!=typeof(part=pattern[i])){if(id=part.id,!values||!hop.call(values,id))throw(err=new Error("A value must be provided for: "+id)).variableId=id,err;value=values[id],part.options?result+=this._format(part.getOption(value),values):result+=part.format(value)}else result+=part;return result},MessageFormat.prototype._mergeFormats=function(defaults,formats){var type,mergedType,mergedFormats={};for(type in defaults)hop.call(defaults,type)&&(mergedFormats[type]=mergedType=objCreate(defaults[type]),formats&&hop.call(formats,type)&&extend(mergedType,formats[type]));return mergedFormats},MessageFormat.prototype._resolveLocale=function(locales){"string"==typeof locales&&(locales=[locales]),locales=(locales||[]).concat(MessageFormat.defaultLocale);var i,len,localeParts,data,localeData=MessageFormat.__localeData__;for(i=0,len=locales.length;i<len;i+=1)for(localeParts=locales[i].toLowerCase().split("-");localeParts.length;){if(data=localeData[localeParts.join("-")])return data.locale;localeParts.pop()}var defaultLocale=locales.pop();throw new Error("No locale data has been added to IntlMessageFormat for: "+locales.join(", ")+", or the default locale: "+defaultLocale)};